/* Copyright 2002-2011 Hiroshi Watabe*/
/* $Id: callbacks.c,v 40c13482f614 2011/02/03 05:56:49 watabe $ */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "gpetview.h"

GtkWidget *filewindow;
GtkWidget *settingshell;
GtkWidget *hdr_info_window;
GtkWidget *clear_dialog;
GtkWidget *aboutDialog;
GtkWidget *overwrite_dialog;

extern void draw_colorbar();
GtkWidget *filewindow;
GtkWidget *settingshell;
GtkWidget *hdr_info_window;
char *fname = NULL;
gushort originY=0,originY2 = 0;
gushort newY = 0, newY2 = 0;
guchar roi_draw_flag = 0;
guchar roi_flag = 0;
guchar pre_roi_flag = 0;
guchar overwrite_flag = 0;
guchar import_flag = 0;
guchar hdr_swap_flag = 0;
guchar pre_color_flag = 0;
guchar redraw_img_flag = 0;
guchar roi_mask_flag = ROI_MASK_IN;
guchar window_ready_flag;
guchar warning_flag = 0;

/* for File selection */
#define IMG_FILE 0
#define IMP_IMG_FILE 1
#define ROI_FILE 2
#define ROI_INF_FILE 3
#define ROI_HIST_FILE 4
#define ROI_PRO_FILE 5
#define HDR_FILE 6
#define LKUP_FILE 7
static guchar file_flag = IMG_FILE;


gboolean
on_gpetview_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  GtkLabel *warning_label;
  const gchar *message = "Are you sure to quit gpetview?";
  warning_label = (GtkLabel *)lookup_widget(warning_dialog,"warning_label");
  gtk_label_set_text(warning_label,message);
  warning_flag = WARNING_QUIT;
  gtk_widget_show(warning_dialog);
  return TRUE;
}

void
on_image_file_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (filewindow);
}


void
on_import_raw_file1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show(import_window);
}


void
on_quit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkLabel *warning_label;
  const gchar *message = "Are you sure to quit gpetview?";
  warning_label = (GtkLabel *)lookup_widget(warning_dialog,"warning_label");
  gtk_label_set_text(warning_label,message);
  warning_flag = WARNING_QUIT;
  gtk_widget_show(warning_dialog);
}


void
on_clear_screen_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkLabel *warning_label;
  const gchar *message = "Do you want to clear screen?";
  warning_label = (GtkLabel *)lookup_widget(warning_dialog,"warning_label");
  gtk_label_set_text(warning_label,message);
  warning_flag = WARNING_CLEAR_SCREEN;
  gtk_widget_show(warning_dialog);
}


void
on_roi_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(view_flag==0) return;
  if(roi_flag!=0) roi_draw_flag = 1;
  gtk_widget_show (roiwindow);
}


void
on_roi_calc_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  roi_set_proc();
}


void
on_setting_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show(settingshell);
}


void
on_filter_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_roi_info_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (roi_info_window);
}


void
on_header_info_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  hdr_info_window = create_hdr_info_window ();
  gtk_widget_show (hdr_info_window);
  hdr_info(hdr_info_window);
}


void
clear_view_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GdkColor bgcolor; /* background color */

  gdk_window_clear(pet_canvas->window);
  /* prepare for background */
  store_color(&bgcolor.pixel,0,0,0);/* black */
  gdk_gc_set_foreground(clearGC,&bgcolor); /* set foreground color for clear canvas */
  gdk_draw_rectangle(canvas_pixmap,clearGC,TRUE,0,0,canvas_width,canvas_height);
  gdk_draw_rectangle(pet_canvas->window,clearGC,TRUE,0,0,canvas_width,canvas_height);
  Curr_imgno = 0;
  now_seq = 1;
  view_flag = 0;
  roi_step = 0;/* roi procedure starts again */
  memset(pre_fname,0,sizeof(pre_fname));
  view_proc(1);
}


void
on_help_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  aboutDialog = create_aboutDialog ();
  gtk_widget_show (aboutDialog);
}


void
on_view_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  view_proc(1);
}


gboolean
on_colorbar_button_press_event         (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  if(event->button == Button1){
    gtk_widget_show(colorbar_window);
    pre_color_flag = color_flag;
    draw_colorbar_mini();
  }
  return FALSE;
}


gboolean
on_colorbar_expose_event               (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  draw_colorbar();
  return FALSE;
}


gboolean
on_canvas_expose_event                 (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
 gdk_window_copy_area(pet_canvas->window,canvasGC,0,0,canvas_pixmap,0,0,canvas_width,canvas_height);
  return FALSE;
}


gboolean
on_canvas_button_press_event           (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  roi_proc(widget,event);
  return FALSE;
}


gboolean
on_canvas_button_release_event         (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_canvas_motion_notify_event          (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
  drag(widget,event);
  return FALSE;
}


void
on_ok_about_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(aboutDialog);
}


gboolean
on_filewindow_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_select_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  file_flag = IMG_FILE;
  gtk_window_set_title(GTK_WINDOW(fileselection),"Select image file");
  gtk_widget_show (fileselection);
}


void
on_load_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *file_entry;
  char message[255];
  const gchar *tmpc;

  file_entry = lookup_widget(filewindow,"file_entry");
  tmpc = gtk_entry_get_text(GTK_ENTRY(file_entry));
  if (strlen (tmpc) == 0)
    return;
  if(fname==NULL){
    fname = (char *)malloc((1+strlen(tmpc)));
  }
  else{
    free(fname);
    fname = (char *)malloc((1+strlen(tmpc)));
  }
  strcpy(fname,tmpc);
  sprintf(message,"Selected File Name = %s",fname);
  put_string(message,0);
  gtk_widget_hide(filewindow);
  set_filename();
}


void
on_save_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *entry;
  const gchar *fname;
  FILE *fp,*fp2;

  entry = lookup_widget(filewindow,"file_entry");
  fname = gtk_entry_get_text(GTK_ENTRY(entry));
  if(strlen(fname)==0) return;
  fp = fopen(header_name(fname),"r");
  fp2 = fopen(image_name(fname),"r");
  if(fp!=NULL||fp2!=NULL){
    overwrite_flag = OW_FILE;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
    fclose(fp);
  }
  else{
    save_file_proc();
  }
}


void
on_cancel_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(filewindow);
}


void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkFileSelection *fs;
  const gchar *c,*raw_filename;
  char filename[1024];
  GtkWidget *filesel;
  GtkWidget *file_entry;
  int i;

  fs = GTK_FILE_SELECTION (fileselection);
  c = gtk_file_selection_get_filename (fs);
  if (strlen(c)>1024) return;//file name is too long
  strcpy(filename,c);

  raw_filename = gtk_entry_get_text (GTK_ENTRY(fs->selection_entry));
  if (strlen (raw_filename) == 0)
    return;
  filesel = gtk_widget_get_toplevel(GTK_WIDGET(button));
  gtk_widget_hide(filesel);
  if(file_flag==IMG_FILE){
    file_entry = lookup_widget(filewindow,"file_entry");
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
  if(file_flag==IMP_IMG_FILE){
    file_entry = lookup_widget(import_window,"import_file_entry");
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
  if(file_flag==ROI_FILE){
    file_entry = lookup_widget(roiwindow,"roi_file_entry");
    for(i=strlen(filename) - 1;i>0;i--){//find extension
      if(filename[i]=='.'){
	filename[i] = 0;
	break;
      }
    }
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
  if(file_flag==ROI_INF_FILE){
    file_entry = lookup_widget(roi_info_window,"roi_info_entry");
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
  if(file_flag==ROI_HIST_FILE){
    file_entry = lookup_widget(hist_window,"hist_entry");
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
  if(file_flag==ROI_PRO_FILE){
    file_entry = lookup_widget(profile_window,"profile_entry");
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
  if(file_flag==HDR_FILE){
    file_entry = lookup_widget(hdr_info_window,"hdr_info_entry");
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
  if(file_flag==LKUP_FILE){
    file_entry = lookup_widget(colorbar_window,"lookup_entry");
    gtk_entry_set_text(GTK_ENTRY(file_entry),filename);
  }
}


void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(fileselection);
}


void
quit_gpetview()
{
  int i;
  char name[100];

  /* delete temporary roi file */
  if(roi_num!=0&&flag_timestamp==0){
    for(i=0;i<roi_num;i++){
#ifdef WIN32
      sprintf(name,"roi%s.%d",timestamp,i+1);
#else
      sprintf(name,"/tmp/roi%s.%d",timestamp,i+1);
#endif
      remove(name);
    }
  }
  gtk_exit(0);
}


gboolean
on_settingshell_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_set_done_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(settingshell);
}


void
on_set_each_image_button_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    imax_flag = EACH_IMAGE;
  }
}


void
on_set_all_image_button_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    imax_flag = ALL_IMAGE;
  }
}


void
on_set_input_user_abs_button_toggled   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    imax_flag = INPUT_USER_ABS;
  }
}


void
on_set_input_user_rel_button_toggled   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    imax_flag = INPUT_USER_REL;
  }
}


void
on_set_trans_button_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    seq_flag = TRANS;
  }
}


void
on_set_coronal_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    seq_flag = CORO;
  }
}


void
on_set_sagital_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    seq_flag = SAGI;
  }
}


void
on_set_num_button_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    numbering_flag = 1;
  }
  else{
    numbering_flag = 0;
  }
}


void
on_set_interpolate_button_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    interpolate_flag = 1;
  }
  else{
    interpolate_flag = 0;
  }
}


void
on_revy_button_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    revy_flag = 1;
  }
  else{
    revy_flag = 0;
  }
}


void clear_screen()
{
  GdkColor bgcolor; /* background color */
  
  gdk_window_clear(pet_canvas->window);
  /* prepare for background */
  store_color(&bgcolor.pixel,0,0,0);/* black */
  gdk_gc_set_foreground(clearGC,&bgcolor); /* set foreground color for clear canvas */
  gdk_draw_rectangle(canvas_pixmap,clearGC,TRUE,0,0,canvas_width,canvas_height);
  gdk_draw_rectangle(pet_canvas->window,clearGC,TRUE,0,0,canvas_width,canvas_height);
  Curr_imgno = 0;
  now_seq = 1;
  view_flag = 0;
  roi_step = 0;/* roi procedure starts again */
  memset(pre_fname,0,sizeof(pre_fname));
}

void
on_roi_info_save_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *entry;
  const gchar *str;
  FILE *fp;

  entry = lookup_widget(roi_info_window,"roi_info_entry");
  str = gtk_entry_get_text(GTK_ENTRY(entry));
  if(strlen(str)==0){
    return;
  }
  fp = fopen(str,"r");
  if(fp!=NULL){ /* file exists */
    overwrite_flag = OW_ROI_INFO;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
    fclose(fp);
  }
  else{
    save_roi_info();
  }
}


void
on_roi_inf_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  file_flag = ROI_INF_FILE;
  gtk_window_set_title(GTK_WINDOW(fileselection),"Select ROI infomation file");
  gtk_widget_show (fileselection);
}


void
on_roi_info_done_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(roi_info_window);
}


void
on_hist_save_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *hist_entry;
  const gchar *str;
  FILE *fp;

  hist_entry = lookup_widget(hist_window,"hist_entry");
  str = gtk_entry_get_text(GTK_ENTRY(hist_entry));
  if(strlen(str)==0){
    return;
  }
  fp = fopen(str,"r");
  if(fp!=NULL){
    overwrite_flag = OW_HIST;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
    fclose(fp);
  }
  else{
    save_hist();
  }
}


void
on_roi_hist_file_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  file_flag = ROI_HIST_FILE;
  gtk_window_set_title(GTK_WINDOW(fileselection),"Select ROI Histogram file");
  gtk_widget_show (fileselection);
}


gboolean
on_hist_curve_motion_notify_event      (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
  on_histogram(event);
  return FALSE;

}


void
on_hist_done_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(hist_window);
}


void
on_hdr_info_save_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *entry;
  const gchar *fname;
  FILE *fp;

  entry = lookup_widget(hdr_info_window,"hdr_info_entry");
  fname = gtk_entry_get_text(GTK_ENTRY(entry));
  if(strlen(fname)==0){
    return;
  }
  fp = fopen(header_name(fname),"r");
  if(fp!=NULL){
    overwrite_flag = OW_HDR;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
    fclose(fp);
  }
  else{
    hdr_save();
  }
}


void
on_swap_hdr_togglebutton_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    hdr_swap_flag = 1;
  }
  else{
    hdr_swap_flag = 0;
  }
}


void
on_hdr_info_file_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  file_flag = HDR_FILE;
  gtk_window_set_title(GTK_WINDOW(fileselection),"Select header file");
  gtk_widget_show (fileselection);
}


void
on_hdr_info_done_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(hdr_info_window);
}


void
on_profile_save_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *profile_entry;
  const gchar *str;
  FILE *fp;

  profile_entry = lookup_widget(profile_window,"profile_entry");
  str = gtk_entry_get_text(GTK_ENTRY(profile_entry));
  if(strlen(str)==0){
    return;
  }
  fp = fopen(str,"wt");
  save_profile(fp);
  fclose(fp);
}


void
on_roi_profile_file_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
  file_flag = ROI_PRO_FILE;
  gtk_window_set_title(GTK_WINDOW(fileselection),"Select profile file");
  gtk_widget_show (fileselection);
}


gboolean
on_profilex_curve_motion_notify_event  (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
  on_profilex(event);
  return FALSE;
}


gboolean
on_profiley_curve_motion_notify_event  (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
  on_profiley(event);
  return FALSE;
}


void
on_profile_done_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(profile_window);
}


void
on_import_file_select_button_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
  file_flag = IMP_IMG_FILE;
  import_flag = 1;
  gtk_window_set_title(GTK_WINDOW(fileselection),"Select import image file");
  gtk_widget_show (fileselection);
}


void
on_import_char_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_UNSIGNED_CHAR;
  }
}


void
on_import_short_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_SIGNED_SHORT;
  }
}


void
on_import_int_button_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_SIGNED_INT;
  }
}


void
on_import_float_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_FLOAT;
  }
}


void
on_import_double_button_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    import_file_type_flag = SPM_DOUBLE;
  }
}


void
on_import_swap_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    need_swap_flag = 1;
  }
  else{
    need_swap_flag = 0;
  }
}


void
on_import_load_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(import_window);
  import_flag = 1;
  import_img(import_window);
  import_flag = 0;
}


void
on_import_cancel_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  import_flag = 0;
  gtk_widget_hide(import_window);
}


gboolean
on_roiwindow_delete_event              (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_roi_circle_button_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = CIRCLE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_ellipse_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = ELLIPSE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_rectangle_button_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = RECTANGLE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_polygon_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = POLYGON;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_find_edge_button_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = FINDEDGE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_distance_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = DISTANCE;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_point_button_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    pre_roi_flag = roi_flag; /*previous roi type */
    roi_flag = figure.type = PICKP;
    if((pre_roi_flag!=roi_flag)&&(pre_x!=0)){
      delete_pre_roi(pre_roi_flag);
      pre_x = 0;
    }
  }
  roi_draw_flag = 1;
}


void
on_roi_non_button_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  roi_draw_flag = 0;
}


void
on_roi_hist_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_show(hist_window);
  hist_set_proc();
}


void
on_roi_profile_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_profile();
}


void
on_roi_copy_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  cproi_proc();
}


void
on_roi_delete_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkLabel *warning_label;
  const gchar *message = "Are you sure to delete the latest ROI?";

  if(roi_draw_flag==0){return;}
  if(roi_num<1) return;
  warning_label = (GtkLabel *)lookup_widget(warning_dialog,"warning_label");
  gtk_label_set_text(warning_label,message);
  warning_flag = WARNING_DELETE_ROI;

  gtk_widget_show(warning_dialog);
  
}

void
on_delete_rois_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkLabel *warning_label;
  const gchar *message = "Are you sure to delete ROIs?";

  if(roi_draw_flag==0){return;}
  if(roi_num<1) return;
  warning_label = (GtkLabel *)lookup_widget(warning_dialog,"warning_label");
  gtk_label_set_text(warning_label,message);
  warning_flag = WARNING_DELETE_ROIS;

  gtk_widget_show(warning_dialog);

}

void
on_roi_mask_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_mask();
}


void
on_roi_mask_in_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    roi_mask_flag = ROI_MASK_IN;
  }
}


void
on_roi_mask_out_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    roi_mask_flag = ROI_MASK_OUT;
  }
}


void
on_roi_file_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  file_flag = ROI_FILE;
  gtk_window_set_title(GTK_WINDOW(fileselection),"Select ROI file");
  gtk_widget_show (fileselection);
}


void
on_roi_save_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  const gchar *str;
  char st2[100];
  gushort n_from,n_to,i;
  FILE *fp;
  GtkWidget *roi_file_entry;
  GtkWidget *roi_no_from_entry;
  GtkWidget *roi_no_to_entry;
  guchar exist_flag;

  roi_file_entry = lookup_widget(roiwindow,"roi_file_entry");
  str =  gtk_entry_get_text(GTK_ENTRY(roi_file_entry));
  if(strlen(str)==0){return;}
  roi_no_from_entry = lookup_widget(roiwindow,"roi_no_from_entry");
  n_from = atoi(gtk_entry_get_text(GTK_ENTRY(roi_no_from_entry)));
  roi_no_to_entry = lookup_widget(roiwindow,"roi_no_to_entry");
  n_to = atoi(gtk_entry_get_text(GTK_ENTRY(roi_no_to_entry)));

  if(n_from==0) n_from = 1;
  if(n_to==0) n_to = roi_num;
  exist_flag = 0;
  for(i=n_from;i<=n_to;i++){
    if(i>roi_num) break;
    sprintf(st2,"%s.roi%d",str,i - n_from + 1);
    fp = fopen(st2,"r");
    if (fp!=NULL){
      exist_flag = 1;
      fclose(fp);
    }
  }
  if (exist_flag){
    overwrite_flag = OW_ROI;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
  }
  else{
    save_roi_proc();
  }
}


void
on_roi_load_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  load_roi_proc();
}


void
on_reset_roi_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  clear_rec();
  roi_draw(6,0,0);
  redraw_canvas();
}


void
on_roi_done_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  if(always_pickp_flag){
    roi_flag = figure.type = PICKP;
    roi_draw_flag = 1;
  }
  else{
    roi_draw_flag = 0;
  }
  roi_step = 0;
  gtk_widget_hide(roiwindow);
}


void
on_roi_calc_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_set_proc();
}


void
on_roi_next_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_next_proc();
}


void
on_roi_back_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  roi_backword_proc();
}


void
on_roi_no_entry_activate               (GtkEntry        *entry,
                                        gpointer         user_data)
{
  int roi_no;

  roi_no = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
  roi_no_spec_proc(roi_no);
}


void
on_overwrite_yes_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(overwrite_dialog);
  if(overwrite_flag==OW_ROI_INFO){
    save_roi_info();
  }
  if(overwrite_flag==OW_HIST){
    save_hist();
  }
  if(overwrite_flag==OW_ROI){
    save_roi_proc();
  }
  if(overwrite_flag==OW_HDR){
    hdr_save();
  }
  if(overwrite_flag==OW_FILE){
    save_file_proc();
  }
  if(overwrite_flag==OW_LKUP){
    save_lookup();
  }
}


void
on_overwrite_no_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(overwrite_dialog);
}


void
on_set_rainbow_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = RAINBOW_COLOR;
    if(window_ready_flag){
      draw_colorbar_mini();
      update_colorbar_mini();
    }
  }
}


void
on_set_hot_button_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = HOT_COLOR;
    if(window_ready_flag){
      draw_colorbar_mini();
      update_colorbar_mini();
    }
  }
}


void
on_set_gray_button_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = GRAY_COLOR;
    if(window_ready_flag){
      draw_colorbar_mini();
      update_colorbar_mini();
    }
  }
}


void
on_set_invgray_button_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = INVGRAY_COLOR;
    if(window_ready_flag){
      draw_colorbar_mini();
    }
  }
}


void
on_set_comb_button_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = COMB_COLOR;
    if(window_ready_flag){
      draw_colorbar_mini();
      update_colorbar_mini();
    }
  }
}


void
on_set_lkup_button_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    color_flag = LKUP_COLOR;
    if(window_ready_flag){
      draw_colorbar_mini();
    }
  }
}


gboolean
on_colorbarcurve_button_press_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  update_colorbar_mini();
  return FALSE;
}


gboolean
on_minicolorbar_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  draw_colorbar_mini();
  update_colorbar_mini();
  return FALSE;
}


void
on_spline_colorbar_radiobutton_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  GtkCurve *curve;

  curve = (GtkCurve *)lookup_widget(colorbar_window,"colorbarcurve");
  if(gtk_toggle_button_get_active(togglebutton)){ 
    gtk_curve_set_curve_type(curve,GTK_CURVE_TYPE_SPLINE);
    update_colorbar_mini();
  }
}


void
on_linear_colorbar_radiobutton_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  GtkCurve *curve;

  curve = (GtkCurve *)lookup_widget(colorbar_window,"colorbarcurve");
  if(gtk_toggle_button_get_active(togglebutton)){ 
    gtk_curve_set_curve_type(curve,GTK_CURVE_TYPE_LINEAR);
    update_colorbar_mini();
  }
}


void
on_colorbar_redraw_checkbutton_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    redraw_img_flag = 1;
  }
  else{
    redraw_img_flag = 0;
  }
}


void
on_looklup_file_select_button_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{
  file_flag = LKUP_FILE;
  gtk_window_set_title(GTK_WINDOW(fileselection),"Select lookup file");
  gtk_widget_show (fileselection);
}


void
on_lookup_file_load_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
  color_flag = LKUP_COLOR;
  if(window_ready_flag){
    draw_colorbar_mini();
  }
}


void
on_lookup_file_save_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *entry;
  const gchar *fname;
  FILE *fp;

  entry = lookup_widget(colorbar_window,"lookup_entry");
  fname = gtk_entry_get_text(GTK_ENTRY(entry));
  if(strlen(fname)==0) return;
  fp = fopen(lkup_name(fname),"r");
  if(fp!=NULL){
    overwrite_flag = OW_LKUP;
    overwrite_dialog = create_overwrite_dialog ();
    gtk_widget_show(overwrite_dialog);
    fclose(fp);
  }
  else{
    save_lookup();
  }
}


void
on_colorbar_ok_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  update_colorbar();
  if(redraw_img_flag){
    now_seq = pre_seq;
    Curr_imgno = Pre_imgno;
    view_proc(0);
  }
  gtk_widget_hide(colorbar_window);
}


void
on_colorbar_reset_button_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkCurve *curve;

  curve = (GtkCurve *)lookup_widget(colorbar_window,"colorbarcurve");
  gtk_curve_reset (curve);
  update_colorbar_mini();
}


void
on_colorbar_cancel_button_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *toggle = NULL;
  /* bring back to pre color */
  color_flag = pre_color_flag;
  if(color_flag==RAINBOW_COLOR){
    toggle = lookup_widget(colorbar_window,"set_rainbow_button");
  }
  if(color_flag==HOT_COLOR){
    toggle = lookup_widget(colorbar_window,"set_hot_button");
  }
  if(color_flag==GRAY_COLOR){
    toggle = lookup_widget(colorbar_window,"set_gray_button");
  }
  if(color_flag==INVGRAY_COLOR){
      toggle = lookup_widget(colorbar_window,"set_invgray_button");
  }
  if(color_flag==LKUP_COLOR){
      toggle = lookup_widget(colorbar_window,"set_lkup_button");
  }
  if(color_flag==COMB_COLOR){
      toggle = lookup_widget(colorbar_window,"set_comb_button");
  }
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (toggle), TRUE);
  gtk_widget_hide(colorbar_window);
}


gboolean
on_canvas_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  printf("debug keyval %d\n",event->keyval);
  return FALSE;
}


void
on_left_roi_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  gushort nowx,nowy;
  gushort corner_x,corner_y;

  if(roi_draw_flag==0) return;
  corner_x = image_cell[curr_img_roi]->r_left;
  corner_y = image_cell[curr_img_roi]->r_top;
  nowx = figure.center.x + corner_x - 1;
  nowy = figure.center.y + corner_y;
  clear_rec();
  roi_draw(1,nowx,nowy);
  redraw_canvas();
}


void
on_up_roi_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  gushort nowx,nowy;
  gushort corner_x,corner_y;

  if(roi_draw_flag==0) return;
  corner_x = image_cell[curr_img_roi]->r_left;
  corner_y = image_cell[curr_img_roi]->r_top;
  nowx = figure.center.x + corner_x;
  nowy = figure.center.y + corner_y - 1;
  clear_rec();
  roi_draw(1,nowx,nowy);
  redraw_canvas();
}


void
on_down_roi_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  gushort nowx,nowy;
  gushort corner_x,corner_y;

  if(roi_draw_flag==0) return;
  corner_x = image_cell[curr_img_roi]->r_left;
  corner_y = image_cell[curr_img_roi]->r_top;
  nowx = figure.center.x + corner_x;
  nowy = figure.center.y + corner_y + 1;
  clear_rec();
  roi_draw(1,nowx,nowy);
  redraw_canvas();
}


void
on_right_roi_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  gushort nowx,nowy;
  gushort corner_x,corner_y;

  if(roi_draw_flag==0) return;
  corner_x = image_cell[curr_img_roi]->r_left;
  corner_y = image_cell[curr_img_roi]->r_top;
  nowx = figure.center.x + corner_x + 1;
  nowy = figure.center.y + corner_y;
  clear_rec();
  roi_draw(1,nowx,nowy);
  redraw_canvas();
}


void
on_label_button_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active(togglebutton)){ 
    labeling_flag = 1;
  }
  else{
    labeling_flag = 0;
  }
  if(view_flag){
    draw_colorbar();
  }
}


void
on_warning_cancelbutton_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(warning_dialog);
}


void
on_warning_okbutton_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  if(warning_flag==WARNING_DELETE_ROI){
    delete_roi();
  }
  if(warning_flag==WARNING_DELETE_ROIS){
    delete_rois();
  }
  if(warning_flag==WARNING_CLEAR_SCREEN){
    clear_screen();
  }
  if(warning_flag==WARNING_QUIT){
    quit_gpetview();
  }
  gtk_widget_hide(warning_dialog);
}


gboolean
on_roi_info_window_delete_event        (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_hide(roi_info_window);
  return TRUE;
}

