/* Copyright 2000-2010 Hiroshi Watabe */
/* check argments */
/* $Id: checkarg.c,v f6f68429ad8f 2010/08/23 18:17:06 watabe $ */
#include "gpetview.h"

gint pipe_fd = 0; /* file descriptor for Pipe if user specified */
guchar stdout_flag = 0; /* if 1, print out results into standard out */
guchar flag_timestamp = 0;
guchar flag_roidir = 0; // specify ROI direcotry for tempolary

const char *hgversion = "$Id: checkarg.c,v f6f68429ad8f 2010/08/23 18:17:06 watabe $";

int checkarg(int argc,char **argv)
{
  int i;
  int num_arg;
  GtkWidget *button = NULL,*entry;

  num_arg = argc - 1;
  for(i=1;i<argc;i++){
    if(argv[i][0]=='-'){
      if(argv[i][1]=='h'){
	fprintf(stderr,"GpetView %s\nUsage:%s [-a amax amin|-b title|-c canvasx canvasy|-d directory|-e|-g roi|-h|-i  1 or 0|-l no|-n  1 or 0|-o|-p|-q slices|-r rmax rmin|-s 0, 1 or 2|-t timestamp|-u lookup file|-w winx winy|-y 1 or 0|-z zoom| image file]\n-a: absolute max, min\n-b: title\n-c: canvas size width=canvasx,height=canvasy\n-d: temp directory for ROI\n-e: max for each slice\n-g: roi name\n-h: this message\n-i: 1 for interpolation on\n-l: color lookup table 0-rainbow 1-hot 2-gray 3-invgray 4-comb 5-lkup\n-n: 1 for numbering on\n-o: output stdout\n-p: get image from pipe\n-q: slice selection\n-r: relative max,min\n-s: 0-trans 1-coronal 2-sagittal\n-t: timestamp (tempolary ROI filename)\n-w: window size width=winx,height=winy\n-u: lookup file\n-y: 1 for reverse Y on\n-z: zoom\n",hgversion,argv[0]);
	exit(1);
      }
      else{
	if(argv[i][1]=='p'){
	  pipe_flag = 1;
	  num_arg--;
	  if(((i+1)<argc)&&(argv[i+1][0]!='-')){
	    pipe_fd = atoi(argv[i + 1]);
	    return 0;
	  }
	}
	else{
	  if(argv[i][1]=='w'&&argv[i][0]=='-'){
	    view_width = atoi(argv[i+1]);
	    view_height = atoi(argv[i+2]);
	    i+=2;
	    num_arg-=3;
	  }
	  else{
	    if(argv[i][1]=='c'&&argv[i][0]=='-'){
	      canvas_width = atoi(argv[i+1]);
	      canvas_height = atoi(argv[i+2]);
	      i+=2;
	      num_arg-=3;
	    }
	    else{
	      if(argv[i][1]=='a'&&argv[i][0]=='-'){
		imax_flag = INPUT_USER_ABS;
		entry = lookup_widget(settingshell,"set_maxv");
		gtk_entry_set_text(GTK_ENTRY(entry),argv[i+1]);
		entry = lookup_widget(settingshell,"set_minv");
		gtk_entry_set_text(GTK_ENTRY(entry),argv[i+2]);
		user_max = atof(argv[i+1]);
		user_min = atof(argv[i+2]);
		button = lookup_widget(settingshell,"set_input_user_abs_button");
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
		i+=2;
		num_arg-=3;
	      }
	      else{
		if(argv[i][1]=='e'&&argv[i][0]=='-'){
		  imax_flag = EACH_IMAGE;
		  button = lookup_widget(settingshell,"set_each_image_button");
		  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
		  num_arg--;
		}
		else{
		  if(argv[i][1]=='r'&&argv[i][0]=='-'){
		    imax_flag = INPUT_USER_REL;
		    entry = lookup_widget(settingshell,"set_maxv");
		    gtk_entry_set_text(GTK_ENTRY(entry),argv[i+1]);
		    entry = lookup_widget(settingshell,"set_minv");
		    gtk_entry_set_text(GTK_ENTRY(entry),argv[i+2]);
		    button = lookup_widget(settingshell,"set_input_user_rel_button");
		    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
		    user_max = atof(argv[i+1]);
		    user_min = atof(argv[i+2]);
		    i+=2;
		    num_arg-=3;
		  }
		  else{
		    if(argv[i][1]=='z'&&argv[i][0]=='-'){
		      button = lookup_widget(settingshell,"set_zoom");
		      gtk_entry_set_text (GTK_ENTRY (button), argv[i+1]);
		      i++;
		      num_arg-=2;
		    }
		    else{
		      if(argv[i][1]=='l'&&argv[i][0]=='-'){
			color_flag = atoi(argv[i+1]);
			if(color_flag==RAINBOW_COLOR){
			  button = lookup_widget(colorbar_window,"set_rainbow_button");
			  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
			}
			if(color_flag==HOT_COLOR){
			  button = lookup_widget(colorbar_window,"set_hot_button");
			  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
			}
			if(color_flag==GRAY_COLOR){
			  button = lookup_widget(colorbar_window,"set_gray_button");
			  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
			}
			if(color_flag==COMB_COLOR){
			  button = lookup_widget(colorbar_window,"set_comb_button");
			  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
			}
			if(color_flag==LKUP_COLOR){
			  button = lookup_widget(colorbar_window,"set_lkup_button");
			  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
			}
			if(color_flag==INVGRAY_COLOR){
			  button = lookup_widget(colorbar_window,"set_invgray_button");
			  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
			}
			i++;
			num_arg-=2;
		      }
		      else{
			if(argv[i][1]=='s'&&argv[i][0]=='-'){
			  seq_flag = atoi(argv[i+1]);
			  if(seq_flag==TRANS){
			    button = lookup_widget(settingshell,"set_trans_button");
			  }
			  if(seq_flag==CORO){
			    button = lookup_widget(settingshell,"set_coronal_button");
			  }
			  if(seq_flag==SAGI){
			    button = lookup_widget(settingshell,"set_sagital_button");
			  }
			  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
			  i++;
			  num_arg-=2;
			}
			else{
			  if(argv[i][1]=='y'&&argv[i][0]=='-'){
			    button = lookup_widget(settingshell,"revy_button");
			    revy_flag = atoi(argv[i+1]);
			    if(revy_flag==1){
			      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
			    }
			    else{
			      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), FALSE);
			    }
			    i++;
			    num_arg-=2;
			  }
			  else{
			    if(argv[i][1]=='i'&&argv[i][0]=='-'){
			      button = lookup_widget(settingshell,"set_interpolate_button");
			      interpolate_flag = atoi(argv[i+1]);
			      if(interpolate_flag==1){
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
			      }
			      else{
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), FALSE);
			      }
			      i++;
			      num_arg-=2;
			    }
			    else{
			      if(argv[i][1]=='n'&&argv[i][0]=='-'){
				button = lookup_widget(settingshell,"set_num_button");
				numbering_flag = atoi(argv[i+1]);
				if(numbering_flag==1){
				  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
				}
				else{
				  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), FALSE);
				}
				i++;
				num_arg-=2;
			      }
			      else{
				if(argv[i][1]=='o'&&argv[i][0]=='-'){/* standard out */
				  num_arg--;
				  stdout_flag = 1;
				}
				else{
				  if(argv[i][1]=='q'&&argv[i][0]=='-'){
				    button = lookup_widget(settingshell,"img_no_entry");
				    gtk_entry_set_text (GTK_ENTRY (button), argv[i+1]);
				    i++;
				    num_arg-=2;
				  }
				  else{
				    if(argv[i][1]=='t'&&argv[i][0]=='-'){
				      if(strlen(argv[i+1])!=0){
					sprintf(timestamp,"%s",argv[i+1]);
					flag_timestamp = 1;
				      }
				      i++;
				      num_arg-=2;
				    }
				    else{
				      if(argv[i][1]=='b'&&argv[i][0]=='-'){/*titile */
					sprintf(title,"%s",argv[i+1]);
					i++;
					num_arg-=2;
				      }
				      else{
					if(argv[i][1]=='u'&&argv[i][0]=='-'){/*lookup file */
					  entry = lookup_widget(colorbar_window,"lookup_entry");
					  gtk_entry_set_text(GTK_ENTRY(entry),argv[i+1]);
					  i++;
					  num_arg-=2;
					}
					else{
					  if(argv[i][1]=='g'&&argv[i][0]=='-'){/*roi name */
					    entry = lookup_widget(roiwindow,"roi_file_entry");
					    gtk_entry_set_text(GTK_ENTRY(entry),argv[i+1]);
					    i++;
					    num_arg-=2;
					  }
					  else{
					    if(argv[i][1]=='d'&&argv[i][0]=='-'){/*roi directory */
					      if(strlen(argv[i+1])!=0){
						sprintf(temproidir,"%s",argv[i+1]);
						flag_roidir = 1;
					      }
					      i++;
					      num_arg-=2;
					    }
					  }
					}
				      }
				    }
				  }
				}
			      }
			    }
			  }
			}
		      }
		    }
		  }
		}
	      }
	    }
	  }
	}
      }
    }
  }
  return(num_arg);
}
