/* Copyright 2000-2011 Hiroshi Watabe*/
/* $Id: draw_colorbar.c,v ad5996c60c95 2011/02/03 09:07:37 watabe $ */
#include "gpetview.h"

void store_rgb();
unsigned char color_flag = RAINBOW_COLOR;
GtkWidget *gcolorbar;
GtkWidget *gcolorbar_mini;
GdkColormap *gcolormap=NULL;/* colormap for PseudoColor */
GdkColor *gpetcolors;
unsigned char labeling_flag = 0;

guchar fred=255,fgreen=255,fblue=255;

static guchar red[256],green[256],blue[256];

static PangoContext *pangocontext;
static PangoLayout *pangolayout;
static PangoFontDescription *pangofontdesc;

/* Setting Rainbow scale*/
void rainbow()
{
  red[0] = 0;green[0] = 0;blue[0] = 0;
  red[1] = 4;green[1] = 0;blue[1] = 4;
  red[2] = 8;green[2] = 0;blue[2] = 8;
  red[3] = 11;green[3] = 0;blue[3] = 11;
  red[4] = 14;green[4] = 0;blue[4] = 14;
  red[5] = 19;green[5] = 0;blue[5] = 18;
  red[6] = 24;green[6] = 0;blue[6] = 23;
  red[7] = 29;green[7] = 0;blue[7] = 28;
  red[8] = 34;green[8] = 0;blue[8] = 33;
  red[9] = 39;green[9] = 0;blue[9] = 38;
  red[10] = 44;green[10] = 0;blue[10] = 43;
  red[11] = 49;green[11] = 0;blue[11] = 48;
  red[12] = 54;green[12] = 0;blue[12] = 53;
  red[13] = 59;green[13] = 0;blue[13] = 57;
  red[14] = 64;green[14] = 0;blue[14] = 62;
  red[15] = 69;green[15] = 0;blue[15] = 67;
  red[16] = 74;green[16] = 0;blue[16] = 72;
  red[17] = 79;green[17] = 0;blue[17] = 77;
  red[18] = 84;green[18] = 0;blue[18] = 82;
  red[19] = 89;green[19] = 0;blue[19] = 87;
  red[20] = 94;green[20] = 0;blue[20] = 92;
  red[21] = 99;green[21] = 0;blue[21] = 97;
  red[22] = 97;green[22] = 0;blue[22] = 101;
  red[23] = 95;green[23] = 0;blue[23] = 106;
  red[24] = 92;green[24] = 0;blue[24] = 111;
  red[25] = 90;green[25] = 0;blue[25] = 116;
  red[26] = 88;green[26] = 0;blue[26] = 121;
  red[27] = 85;green[27] = 0;blue[27] = 126;
  red[28] = 83;green[28] = 0;blue[28] = 131;
  red[29] = 80;green[29] = 0;blue[29] = 136;
  red[30] = 78;green[30] = 0;blue[30] = 140;
  red[31] = 76;green[31] = 0;blue[31] = 145;
  red[32] = 73;green[32] = 0;blue[32] = 150;
  red[33] = 71;green[33] = 0;blue[33] = 155;
  red[34] = 68;green[34] = 0;blue[34] = 160;
  red[35] = 66;green[35] = 0;blue[35] = 165;
  red[36] = 64;green[36] = 0;blue[36] = 170;
  red[37] = 61;green[37] = 0;blue[37] = 175;
  red[38] = 59;green[38] = 0;blue[38] = 180;
  red[39] = 57;green[39] = 0;blue[39] = 184;
  red[40] = 54;green[40] = 0;blue[40] = 189;
  red[41] = 52;green[41] = 0;blue[41] = 194;
  red[42] = 49;green[42] = 0;blue[42] = 200;
  red[43] = 47;green[43] = 0;blue[43] = 200;
  red[44] = 45;green[44] = 0;blue[44] = 201;
  red[45] = 42;green[45] = 0;blue[45] = 203;
  red[46] = 40;green[46] = 0;blue[46] = 204;
  red[47] = 38;green[47] = 0;blue[47] = 206;
  red[48] = 35;green[48] = 0;blue[48] = 207;
  red[49] = 33;green[49] = 0;blue[49] = 209;
  red[50] = 30;green[50] = 0;blue[50] = 210;
  red[51] = 28;green[51] = 0;blue[51] = 211;
  red[52] = 26;green[52] = 0;blue[52] = 212;
  red[53] = 23;green[53] = 1;blue[53] = 213;
  red[54] = 20;green[54] = 5;blue[54] = 215;
  red[55] = 18;green[55] = 8;blue[55] = 216;
  red[56] = 16;green[56] = 13;blue[56] = 218;
  red[57] = 14;green[57] = 17;blue[57] = 219;
  red[58] = 11;green[58] = 21;blue[58] = 220;
  red[59] = 8;green[59] = 24;blue[59] = 222;
  red[60] = 6;green[60] = 28;blue[60] = 223;
  red[61] = 4;green[61] = 31;blue[61] = 224;
  red[62] = 2;green[62] = 35;blue[62] = 225;
  red[63] = 0;green[63] = 40;blue[63] = 227;
  red[64] = 0;green[64] = 44;blue[64] = 228;
  red[65] = 0;green[65] = 47;blue[65] = 229;
  red[66] = 0;green[66] = 51;blue[66] = 231;
  red[67] = 0;green[67] = 55;blue[67] = 232;
  red[68] = 0;green[68] = 59;blue[68] = 233;
  red[69] = 0;green[69] = 63;blue[69] = 234;
  red[70] = 0;green[70] = 66;blue[70] = 236;
  red[71] = 0;green[71] = 70;blue[71] = 237;
  red[72] = 0;green[72] = 74;blue[72] = 238;
  red[73] = 0;green[73] = 78;blue[73] = 240;
  red[74] = 0;green[74] = 82;blue[74] = 241;
  red[75] = 0;green[75] = 85;blue[75] = 243;
  red[76] = 0;green[76] = 89;blue[76] = 244;
  red[77] = 0;green[77] = 93;blue[77] = 245;
  red[78] = 0;green[78] = 97;blue[78] = 246;
  red[79] = 0;green[79] = 101;blue[79] = 247;
  red[80] = 0;green[80] = 105;blue[80] = 249;
  red[81] = 0;green[81] = 108;blue[81] = 250;
  red[82] = 0;green[82] = 112;blue[82] = 252;
  red[83] = 0;green[83] = 116;blue[83] = 253;
  red[84] = 0;green[84] = 120;blue[84] = 254;
  red[85] = 0;green[85] = 124;blue[85] = 251;
  red[86] = 0;green[86] = 127;blue[86] = 248;
  red[87] = 0;green[87] = 131;blue[87] = 245;
  red[88] = 0;green[88] = 135;blue[88] = 242;
  red[89] = 0;green[89] = 139;blue[89] = 239;
  red[90] = 0;green[90] = 143;blue[90] = 235;
  red[91] = 0;green[91] = 146;blue[91] = 232;
  red[92] = 0;green[92] = 150;blue[92] = 229;
  red[93] = 0;green[93] = 154;blue[93] = 227;
  red[94] = 0;green[94] = 158;blue[94] = 224;
  red[95] = 0;green[95] = 162;blue[95] = 221;
  red[96] = 0;green[96] = 166;blue[96] = 217;
  red[97] = 0;green[97] = 169;blue[97] = 214;
  red[98] = 0;green[98] = 173;blue[98] = 211;
  red[99] = 0;green[99] = 177;blue[99] = 208;
  red[100] = 0;green[100] = 181;blue[100] = 206;
  red[101] = 0;green[101] = 185;blue[101] = 203;
  red[102] = 0;green[102] = 188;blue[102] = 199;
  red[103] = 0;green[103] = 192;blue[103] = 196;
  red[104] = 0;green[104] = 196;blue[104] = 193;
  red[105] = 0;green[105] = 200;blue[105] = 190;
  red[106] = 0;green[106] = 201;blue[106] = 187;
  red[107] = 0;green[107] = 202;blue[107] = 184;
  red[108] = 0;green[108] = 204;blue[108] = 181;
  red[109] = 0;green[109] = 206;blue[109] = 178;
  red[110] = 0;green[110] = 208;blue[110] = 175;
  red[111] = 0;green[111] = 210;blue[111] = 172;
  red[112] = 0;green[112] = 212;blue[112] = 169;
  red[113] = 0;green[113] = 213;blue[113] = 166;
  red[114] = 0;green[114] = 215;blue[114] = 163;
  red[115] = 0;green[115] = 217;blue[115] = 160;
  red[116] = 0;green[116] = 219;blue[116] = 157;
  red[117] = 0;green[117] = 221;blue[117] = 154;
  red[118] = 0;green[118] = 222;blue[118] = 151;
  red[119] = 0;green[119] = 224;blue[119] = 148;
  red[120] = 0;green[120] = 225;blue[120] = 144;
  red[121] = 0;green[121] = 227;blue[121] = 142;
  red[122] = 0;green[122] = 229;blue[122] = 139;
  red[123] = 0;green[123] = 231;blue[123] = 135;
  red[124] = 0;green[124] = 233;blue[124] = 132;
  red[125] = 0;green[125] = 234;blue[125] = 129;
  red[126] = 0;green[126] = 236;blue[126] = 126;
  red[127] = 0;green[127] = 238;blue[127] = 123;
  red[128] = 0;green[128] = 240;blue[128] = 121;
  red[129] = 0;green[129] = 241;blue[129] = 117;
  red[130] = 0;green[130] = 243;blue[130] = 114;
  red[131] = 0;green[131] = 245;blue[131] = 111;
  red[132] = 0;green[132] = 246;blue[132] = 108;
  red[133] = 0;green[133] = 249;blue[133] = 104;
  red[134] = 0;green[134] = 252;blue[134] = 99;
  red[135] = 0;green[135] = 253;blue[135] = 95;
  red[136] = 0;green[136] = 254;blue[136] = 93;
  red[137] = 0;green[137] = 255;blue[137] = 91;
  red[138] = 0;green[138] = 255;blue[138] = 89;
  red[139] = 0;green[139] = 255;blue[139] = 87;
  red[140] = 0;green[140] = 255;blue[140] = 83;
  red[141] = 0;green[141] = 255;blue[141] = 80;
  red[142] = 0;green[142] = 255;blue[142] = 77;
  red[143] = 0;green[143] = 255;blue[143] = 75;
  red[144] = 0;green[144] = 255;blue[144] = 72;
  red[145] = 0;green[145] = 255;blue[145] = 69;
  red[146] = 0;green[146] = 255;blue[146] = 65;
  red[147] = 0;green[147] = 255;blue[147] = 62;
  red[148] = 6;green[148] = 255;blue[148] = 59;
  red[149] = 12;green[149] = 255;blue[149] = 56;
  red[150] = 18;green[150] = 255;blue[150] = 54;
  red[151] = 24;green[151] = 255;blue[151] = 51;
  red[152] = 30;green[152] = 255;blue[152] = 47;
  red[153] = 36;green[153] = 255;blue[153] = 44;
  red[154] = 43;green[154] = 255;blue[154] = 41;
  red[155] = 49;green[155] = 255;blue[155] = 38;
  red[156] = 55;green[156] = 255;blue[156] = 35;
  red[157] = 60;green[157] = 255;blue[157] = 32;
  red[158] = 66;green[158] = 255;blue[158] = 29;
  red[159] = 73;green[159] = 255;blue[159] = 26;
  red[160] = 79;green[160] = 255;blue[160] = 23;
  red[161] = 85;green[161] = 255;blue[161] = 20;
  red[162] = 91;green[162] = 255;blue[162] = 17;
  red[163] = 97;green[163] = 255;blue[163] = 14;
  red[164] = 103;green[164] = 255;blue[164] = 11;
  red[165] = 109;green[165] = 255;blue[165] = 8;
  red[166] = 115;green[166] = 255;blue[166] = 5;
  red[167] = 121;green[167] = 255;blue[167] = 2;
  red[168] = 127;green[168] = 255;blue[168] = 0;
  red[169] = 134;green[169] = 255;blue[169] = 0;
  red[170] = 140;green[170] = 255;blue[170] = 0;
  red[171] = 146;green[171] = 255;blue[171] = 0;
  red[172] = 152;green[172] = 255;blue[172] = 0;
  red[173] = 158;green[173] = 255;blue[173] = 0;
  red[174] = 164;green[174] = 255;blue[174] = 0;
  red[175] = 170;green[175] = 255;blue[175] = 0;
  red[176] = 176;green[176] = 255;blue[176] = 0;
  red[177] = 182;green[177] = 255;blue[177] = 0;
  red[178] = 188;green[178] = 255;blue[178] = 0;
  red[179] = 194;green[179] = 255;blue[179] = 0;
  red[180] = 201;green[180] = 255;blue[180] = 0;
  red[181] = 207;green[181] = 255;blue[181] = 0;
  red[182] = 212;green[182] = 255;blue[182] = 0;
  red[183] = 218;green[183] = 255;blue[183] = 0;
  red[184] = 224;green[184] = 255;blue[184] = 0;
  red[185] = 231;green[185] = 255;blue[185] = 0;
  red[186] = 237;green[186] = 255;blue[186] = 0;
  red[187] = 243;green[187] = 255;blue[187] = 0;
  red[188] = 249;green[188] = 255;blue[188] = 0;
  red[189] = 255;green[189] = 254;blue[189] = 0;
  red[190] = 255;green[190] = 250;blue[190] = 0;
  red[191] = 255;green[191] = 246;blue[191] = 0;
  red[192] = 255;green[192] = 243;blue[192] = 0;
  red[193] = 255;green[193] = 239;blue[193] = 0;
  red[194] = 255;green[194] = 235;blue[194] = 0;
  red[195] = 255;green[195] = 231;blue[195] = 0;
  red[196] = 255;green[196] = 227;blue[196] = 0;
  red[197] = 255;green[197] = 223;blue[197] = 0;
  red[198] = 255;green[198] = 220;blue[198] = 0;
  red[199] = 255;green[199] = 216;blue[199] = 0;
  red[200] = 255;green[200] = 212;blue[200] = 0;
  red[201] = 255;green[201] = 208;blue[201] = 0;
  red[202] = 255;green[202] = 204;blue[202] = 0;
  red[203] = 255;green[203] = 201;blue[203] = 0;
  red[204] = 255;green[204] = 197;blue[204] = 0;
  red[205] = 255;green[205] = 193;blue[205] = 0;
  red[206] = 255;green[206] = 189;blue[206] = 0;
  red[207] = 255;green[207] = 185;blue[207] = 0;
  red[208] = 255;green[208] = 181;blue[208] = 0;
  red[209] = 255;green[209] = 178;blue[209] = 0;
  red[210] = 255;green[210] = 174;blue[210] = 0;
  red[211] = 255;green[211] = 170;blue[211] = 0;
  red[212] = 255;green[212] = 166;blue[212] = 0;
  red[213] = 255;green[213] = 162;blue[213] = 0;
  red[214] = 255;green[214] = 159;blue[214] = 0;
  red[215] = 255;green[215] = 155;blue[215] = 0;
  red[216] = 255;green[216] = 151;blue[216] = 0;
  red[217] = 255;green[217] = 147;blue[217] = 0;
  red[218] = 255;green[218] = 143;blue[218] = 0;
  red[219] = 255;green[219] = 140;blue[219] = 0;
  red[220] = 255;green[220] = 136;blue[220] = 0;
  red[221] = 255;green[221] = 132;blue[221] = 0;
  red[222] = 255;green[222] = 128;blue[222] = 0;
  red[223] = 255;green[223] = 124;blue[223] = 0;
  red[224] = 255;green[224] = 121;blue[224] = 0;
  red[225] = 255;green[225] = 117;blue[225] = 0;
  red[226] = 255;green[226] = 113;blue[226] = 0;
  red[227] = 255;green[227] = 109;blue[227] = 0;
  red[228] = 255;green[228] = 105;blue[228] = 0;
  red[229] = 255;green[229] = 101;blue[229] = 0;
  red[230] = 255;green[230] = 98;blue[230] = 0;
  red[231] = 255;green[231] = 94;blue[231] = 0;
  red[232] = 255;green[232] = 90;blue[232] = 0;
  red[233] = 255;green[233] = 86;blue[233] = 0;
  red[234] = 255;green[234] = 82;blue[234] = 0;
  red[235] = 255;green[235] = 79;blue[235] = 0;
  red[236] = 255;green[236] = 75;blue[236] = 0;
  red[237] = 255;green[237] = 71;blue[237] = 0;
  red[238] = 255;green[238] = 67;blue[238] = 0;
  red[239] = 255;green[239] = 63;blue[239] = 0;
  red[240] = 255;green[240] = 60;blue[240] = 0;
  red[241] = 255;green[241] = 56;blue[241] = 0;
  red[242] = 255;green[242] = 52;blue[242] = 0;
  red[243] = 255;green[243] = 48;blue[243] = 0;
  red[244] = 255;green[244] = 44;blue[244] = 0;
  red[245] = 255;green[245] = 40;blue[245] = 0;
  red[246] = 255;green[246] = 37;blue[246] = 0;
  red[247] = 255;green[247] = 33;blue[247] = 0;
  red[248] = 255;green[248] = 29;blue[248] = 0;
  red[249] = 255;green[249] = 25;blue[249] = 0;
  red[250] = 255;green[250] = 21;blue[250] = 0;
  red[251] = 255;green[251] = 18;blue[251] = 0;
  red[252] = 255;green[252] = 14;blue[252] = 0;
  red[253] = 255;green[253] = 9;blue[253] = 0;
  red[254] = 255;green[254] = 5;blue[254] = 0;
  red[255] = 255;green[255] = 2;blue[255] = 0;
}

void hotcolor()
{
  red[0] = 0;green[0] = 0;blue[0] = 0;
  red[1] = 0;green[1] = 0;blue[1] = 0;
  red[2] = 1;green[2] = 0;blue[2] = 0;
  red[3] = 2;green[3] = 0;blue[3] = 0;
  red[4] = 4;green[4] = 0;blue[4] = 0;
  red[5] = 6;green[5] = 0;blue[5] = 0;
  red[6] = 8;green[6] = 0;blue[6] = 0;
  red[7] = 9;green[7] = 0;blue[7] = 0;
  red[8] = 10;green[8] = 0;blue[8] = 0;
  red[9] = 11;green[9] = 0;blue[9] = 0;
  red[10] = 13;green[10] = 0;blue[10] = 0;
  red[11] = 14;green[11] = 0;blue[11] = 0;
  red[12] = 15;green[12] = 0;blue[12] = 0;
  red[13] = 16;green[13] = 0;blue[13] = 0;
  red[14] = 18;green[14] = 0;blue[14] = 0;
  red[15] = 19;green[15] = 0;blue[15] = 0;
  red[16] = 21;green[16] = 0;blue[16] = 0;
  red[17] = 22;green[17] = 0;blue[17] = 0;
  red[18] = 24;green[18] = 0;blue[18] = 0;
  red[19] = 25;green[19] = 0;blue[19] = 0;
  red[20] = 26;green[20] = 0;blue[20] = 0;
  red[21] = 27;green[21] = 0;blue[21] = 0;
  red[22] = 29;green[22] = 0;blue[22] = 0;
  red[23] = 30;green[23] = 0;blue[23] = 0;
  red[24] = 32;green[24] = 0;blue[24] = 0;
  red[25] = 33;green[25] = 0;blue[25] = 0;
  red[26] = 35;green[26] = 0;blue[26] = 0;
  red[27] = 36;green[27] = 0;blue[27] = 0;
  red[28] = 37;green[28] = 0;blue[28] = 0;
  red[29] = 38;green[29] = 0;blue[29] = 0;
  red[30] = 39;green[30] = 0;blue[30] = 0;
  red[31] = 40;green[31] = 0;blue[31] = 0;
  red[32] = 42;green[32] = 0;blue[32] = 0;
  red[33] = 43;green[33] = 0;blue[33] = 0;
  red[34] = 44;green[34] = 0;blue[34] = 0;
  red[35] = 45;green[35] = 0;blue[35] = 0;
  red[36] = 47;green[36] = 0;blue[36] = 0;
  red[37] = 48;green[37] = 0;blue[37] = 0;
  red[38] = 50;green[38] = 0;blue[38] = 0;
  red[39] = 51;green[39] = 0;blue[39] = 0;
  red[40] = 53;green[40] = 0;blue[40] = 0;
  red[41] = 54;green[41] = 0;blue[41] = 0;
  red[42] = 56;green[42] = 0;blue[42] = 0;
  red[43] = 57;green[43] = 0;blue[43] = 0;
  red[44] = 59;green[44] = 0;blue[44] = 0;
  red[45] = 60;green[45] = 0;blue[45] = 0;
  red[46] = 62;green[46] = 0;blue[46] = 0;
  red[47] = 64;green[47] = 0;blue[47] = 0;
  red[48] = 66;green[48] = 0;blue[48] = 0;
  red[49] = 67;green[49] = 0;blue[49] = 0;
  red[50] = 68;green[50] = 0;blue[50] = 0;
  red[51] = 69;green[51] = 0;blue[51] = 0;
  red[52] = 71;green[52] = 0;blue[52] = 0;
  red[53] = 72;green[53] = 0;blue[53] = 0;
  red[54] = 74;green[54] = 0;blue[54] = 0;
  red[55] = 75;green[55] = 0;blue[55] = 0;
  red[56] = 77;green[56] = 0;blue[56] = 0;
  red[57] = 78;green[57] = 0;blue[57] = 0;
  red[58] = 79;green[58] = 0;blue[58] = 0;
  red[59] = 80;green[59] = 0;blue[59] = 0;
  red[60] = 82;green[60] = 0;blue[60] = 0;
  red[61] = 83;green[61] = 0;blue[61] = 0;
  red[62] = 85;green[62] = 0;blue[62] = 0;
  red[63] = 86;green[63] = 0;blue[63] = 0;
  red[64] = 87;green[64] = 0;blue[64] = 0;
  red[65] = 88;green[65] = 0;blue[65] = 0;
  red[66] = 90;green[66] = 0;blue[66] = 0;
  red[67] = 91;green[67] = 0;blue[67] = 0;
  red[68] = 93;green[68] = 0;blue[68] = 0;
  red[69] = 94;green[69] = 0;blue[69] = 0;
  red[70] = 96;green[70] = 0;blue[70] = 0;
  red[71] = 97;green[71] = 0;blue[71] = 0;
  red[72] = 99;green[72] = 0;blue[72] = 0;
  red[73] = 100;green[73] = 0;blue[73] = 0;
  red[74] = 102;green[74] = 0;blue[74] = 0;
  red[75] = 103;green[75] = 0;blue[75] = 0;
  red[76] = 105;green[76] = 0;blue[76] = 0;
  red[77] = 106;green[77] = 0;blue[77] = 0;
  red[78] = 108;green[78] = 0;blue[78] = 0;
  red[79] = 109;green[79] = 0;blue[79] = 0;
  red[80] = 111;green[80] = 0;blue[80] = 0;
  red[81] = 112;green[81] = 0;blue[81] = 0;
  red[82] = 114;green[82] = 0;blue[82] = 0;
  red[83] = 115;green[83] = 0;blue[83] = 0;
  red[84] = 117;green[84] = 0;blue[84] = 0;
  red[85] = 118;green[85] = 0;blue[85] = 0;
  red[86] = 120;green[86] = 0;blue[86] = 0;
  red[87] = 121;green[87] = 0;blue[87] = 0;
  red[88] = 122;green[88] = 0;blue[88] = 0;
  red[89] = 123;green[89] = 0;blue[89] = 0;
  red[90] = 125;green[90] = 0;blue[90] = 0;
  red[91] = 126;green[91] = 0;blue[91] = 0;
  red[92] = 128;green[92] = 0;blue[92] = 0;
  red[93] = 129;green[93] = 0;blue[93] = 0;
  red[94] = 130;green[94] = 0;blue[94] = 0;
  red[95] = 131;green[95] = 0;blue[95] = 0;
  red[96] = 133;green[96] = 0;blue[96] = 0;
  red[97] = 134;green[97] = 0;blue[97] = 0;
  red[98] = 136;green[98] = 0;blue[98] = 0;
  red[99] = 137;green[99] = 0;blue[99] = 0;
  red[100] = 138;green[100] = 0;blue[100] = 0;
  red[101] = 139;green[101] = 0;blue[101] = 0;
  red[102] = 141;green[102] = 0;blue[102] = 0;
  red[103] = 142;green[103] = 0;blue[103] = 0;
  red[104] = 143;green[104] = 0;blue[104] = 0;
  red[105] = 144;green[105] = 0;blue[105] = 0;
  red[106] = 146;green[106] = 0;blue[106] = 0;
  red[107] = 147;green[107] = 0;blue[107] = 0;
  red[108] = 149;green[108] = 0;blue[108] = 0;
  red[109] = 150;green[109] = 0;blue[109] = 0;
  red[110] = 152;green[110] = 0;blue[110] = 0;
  red[111] = 153;green[111] = 0;blue[111] = 0;
  red[112] = 154;green[112] = 0;blue[112] = 0;
  red[113] = 155;green[113] = 0;blue[113] = 0;
  red[114] = 157;green[114] = 0;blue[114] = 0;
  red[115] = 159;green[115] = 0;blue[115] = 0;
  red[116] = 161;green[116] = 0;blue[116] = 0;
  red[117] = 162;green[117] = 0;blue[117] = 0;
  red[118] = 164;green[118] = 0;blue[118] = 0;
  red[119] = 165;green[119] = 0;blue[119] = 0;
  red[120] = 167;green[120] = 0;blue[120] = 0;
  red[121] = 168;green[121] = 0;blue[121] = 0;
  red[122] = 170;green[122] = 0;blue[122] = 0;
  red[123] = 171;green[123] = 0;blue[123] = 0;
  red[124] = 173;green[124] = 0;blue[124] = 0;
  red[125] = 174;green[125] = 0;blue[125] = 0;
  red[126] = 175;green[126] = 0;blue[126] = 0;
  red[127] = 176;green[127] = 0;blue[127] = 0;
  red[128] = 178;green[128] = 0;blue[128] = 0;
  red[129] = 179;green[129] = 1;blue[129] = 0;
  red[130] = 180;green[130] = 2;blue[130] = 0;
  red[131] = 181;green[131] = 4;blue[131] = 0;
  red[132] = 182;green[132] = 7;blue[132] = 0;
  red[133] = 184;green[133] = 10;blue[133] = 0;
  red[134] = 186;green[134] = 14;blue[134] = 0;
  red[135] = 187;green[135] = 17;blue[135] = 0;
  red[136] = 189;green[136] = 20;blue[136] = 0;
  red[137] = 190;green[137] = 22;blue[137] = 0;
  red[138] = 191;green[138] = 25;blue[138] = 0;
  red[139] = 192;green[139] = 27;blue[139] = 0;
  red[140] = 193;green[140] = 29;blue[140] = 0;
  red[141] = 195;green[141] = 32;blue[141] = 0;
  red[142] = 197;green[142] = 36;blue[142] = 0;
  red[143] = 198;green[143] = 39;blue[143] = 0;
  red[144] = 200;green[144] = 42;blue[144] = 0;
  red[145] = 201;green[145] = 44;blue[145] = 0;
  red[146] = 202;green[146] = 47;blue[146] = 0;
  red[147] = 203;green[147] = 49;blue[147] = 0;
  red[148] = 204;green[148] = 51;blue[148] = 0;
  red[149] = 205;green[149] = 54;blue[149] = 0;
  red[150] = 207;green[150] = 57;blue[150] = 0;
  red[151] = 209;green[151] = 61;blue[151] = 0;
  red[152] = 211;green[152] = 65;blue[152] = 0;
  red[153] = 212;green[153] = 67;blue[153] = 0;
  red[154] = 213;green[154] = 69;blue[154] = 0;
  red[155] = 214;green[155] = 71;blue[155] = 0;
  red[156] = 215;green[156] = 73;blue[156] = 0;
  red[157] = 216;green[157] = 76;blue[157] = 0;
  red[158] = 218;green[158] = 80;blue[158] = 0;
  red[159] = 220;green[159] = 83;blue[159] = 0;
  red[160] = 222;green[160] = 87;blue[160] = 0;
  red[161] = 223;green[161] = 89;blue[161] = 0;
  red[162] = 224;green[162] = 91;blue[162] = 0;
  red[163] = 225;green[163] = 93;blue[163] = 0;
  red[164] = 226;green[164] = 96;blue[164] = 0;
  red[165] = 228;green[165] = 99;blue[165] = 0;
  red[166] = 230;green[166] = 102;blue[166] = 0;
  red[167] = 232;green[167] = 105;blue[167] = 0;
  red[168] = 234;green[168] = 109;blue[168] = 0;
  red[169] = 235;green[169] = 111;blue[169] = 0;
  red[170] = 236;green[170] = 114;blue[170] = 0;
  red[171] = 237;green[171] = 115;blue[171] = 0;
  red[172] = 238;green[172] = 117;blue[172] = 0;
  red[173] = 239;green[173] = 119;blue[173] = 0;
  red[174] = 241;green[174] = 121;blue[174] = 0;
  red[175] = 242;green[175] = 123;blue[175] = 0;
  red[176] = 243;green[176] = 126;blue[176] = 0;
  red[177] = 244;green[177] = 128;blue[177] = 0;
  red[178] = 246;green[178] = 131;blue[178] = 0;
  red[179] = 247;green[179] = 133;blue[179] = 0;
  red[180] = 248;green[180] = 136;blue[180] = 0;
  red[181] = 249;green[181] = 139;blue[181] = 0;
  red[182] = 251;green[182] = 142;blue[182] = 0;
  red[183] = 252;green[183] = 145;blue[183] = 0;
  red[184] = 253;green[184] = 149;blue[184] = 0;
  red[185] = 253;green[185] = 152;blue[185] = 0;
  red[186] = 254;green[186] = 156;blue[186] = 0;
  red[187] = 254;green[187] = 159;blue[187] = 0;
  red[188] = 255;green[188] = 163;blue[188] = 0;
  red[189] = 255;green[189] = 166;blue[189] = 0;
  red[190] = 255;green[190] = 170;blue[190] = 0;
  red[191] = 255;green[191] = 173;blue[191] = 0;
  red[192] = 255;green[192] = 176;blue[192] = 0;
  red[193] = 254;green[193] = 178;blue[193] = 1;
  red[194] = 254;green[194] = 180;blue[194] = 2;
  red[195] = 254;green[195] = 182;blue[195] = 5;
  red[196] = 255;green[196] = 185;blue[196] = 8;
  red[197] = 255;green[197] = 188;blue[197] = 12;
  red[198] = 255;green[198] = 192;blue[198] = 17;
  red[199] = 254;green[199] = 195;blue[199] = 22;
  red[200] = 254;green[200] = 198;blue[200] = 27;
  red[201] = 254;green[201] = 200;blue[201] = 30;
  red[202] = 255;green[202] = 203;blue[202] = 34;
  red[203] = 255;green[203] = 205;blue[203] = 37;
  red[204] = 255;green[204] = 207;blue[204] = 40;
  red[205] = 254;green[205] = 209;blue[205] = 43;
  red[206] = 254;green[206] = 212;blue[206] = 47;
  red[207] = 254;green[207] = 215;blue[207] = 51;
  red[208] = 254;green[208] = 218;blue[208] = 55;
  red[209] = 254;green[209] = 221;blue[209] = 59;
  red[210] = 254;green[210] = 224;blue[210] = 64;
  red[211] = 254;green[211] = 227;blue[211] = 68;
  red[212] = 255;green[212] = 230;blue[212] = 73;
  red[213] = 255;green[213] = 233;blue[213] = 77;
  red[214] = 255;green[214] = 237;blue[214] = 81;
  red[215] = 255;green[215] = 240;blue[215] = 85;
  red[216] = 255;green[216] = 243;blue[216] = 89;
  red[217] = 255;green[217] = 245;blue[217] = 92;
  red[218] = 255;green[218] = 248;blue[218] = 96;
  red[219] = 255;green[219] = 250;blue[219] = 100;
  red[220] = 255;green[220] = 252;blue[220] = 104;
  red[221] = 255;green[221] = 253;blue[221] = 108;
  red[222] = 255;green[222] = 254;blue[222] = 113;
  red[223] = 255;green[223] = 254;blue[223] = 117;
  red[224] = 255;green[224] = 255;blue[224] = 121;
  red[225] = 255;green[225] = 255;blue[225] = 125;
  red[226] = 255;green[226] = 255;blue[226] = 129;
  red[227] = 255;green[227] = 255;blue[227] = 133;
  red[228] = 255;green[228] = 255;blue[228] = 137;
  red[229] = 255;green[229] = 255;blue[229] = 141;
  red[230] = 255;green[230] = 255;blue[230] = 145;
  red[231] = 255;green[231] = 255;blue[231] = 149;
  red[232] = 255;green[232] = 255;blue[232] = 154;
  red[233] = 255;green[233] = 255;blue[233] = 158;
  red[234] = 255;green[234] = 255;blue[234] = 163;
  red[235] = 255;green[235] = 255;blue[235] = 167;
  red[236] = 255;green[236] = 255;blue[236] = 171;
  red[237] = 255;green[237] = 255;blue[237] = 175;
  red[238] = 255;green[238] = 255;blue[238] = 179;
  red[239] = 255;green[239] = 255;blue[239] = 182;
  red[240] = 255;green[240] = 255;blue[240] = 186;
  red[241] = 255;green[241] = 255;blue[241] = 190;
  red[242] = 255;green[242] = 255;blue[242] = 194;
  red[243] = 255;green[243] = 255;blue[243] = 197;
  red[244] = 255;green[244] = 255;blue[244] = 201;
  red[245] = 255;green[245] = 255;blue[245] = 205;
  red[246] = 255;green[246] = 255;blue[246] = 209;
  red[247] = 255;green[247] = 255;blue[247] = 212;
  red[248] = 255;green[248] = 255;blue[248] = 216;
  red[249] = 255;green[249] = 255;blue[249] = 220;
  red[250] = 255;green[250] = 255;blue[250] = 224;
  red[251] = 255;green[251] = 255;blue[251] = 228;
  red[252] = 255;green[252] = 255;blue[252] = 232;
  red[253] = 255;green[253] = 255;blue[253] = 236;
  red[254] = 255;green[254] = 255;blue[254] = 240;
  red[255] = 255;green[255] = 255;blue[255] = 244;
}

void combcolor()
{
  int i;

  for(i=0;i<128;i++)
    red[i] = green[i] = blue[i] = i*2;

  red[128] = 0;green[128] = 0;blue[128] = 0;
  red[129] = 8;green[129] = 0;blue[129] = 8;
  red[130] = 14;green[130] = 0;blue[130] = 14;
  red[131] = 24;green[131] = 0;blue[131] = 23;
  red[132] = 34;green[132] = 0;blue[132] = 33;
  red[133] = 44;green[133] = 0;blue[133] = 43;
  red[134] = 54;green[134] = 0;blue[134] = 53;
  red[135] = 64;green[135] = 0;blue[135] = 62;
  red[136] = 74;green[136] = 0;blue[136] = 72;
  red[137] = 84;green[137] = 0;blue[137] = 82;
  red[138] = 94;green[138] = 0;blue[138] = 92;
  red[139] = 97;green[139] = 0;blue[139] = 101;
  red[140] = 92;green[140] = 0;blue[140] = 111;
  red[141] = 88;green[141] = 0;blue[141] = 121;
  red[142] = 83;green[142] = 0;blue[142] = 131;
  red[143] = 78;green[143] = 0;blue[143] = 140;
  red[144] = 73;green[144] = 0;blue[144] = 150;
  red[145] = 68;green[145] = 0;blue[145] = 160;
  red[146] = 64;green[146] = 0;blue[146] = 170;
  red[147] = 59;green[147] = 0;blue[147] = 180;
  red[148] = 54;green[148] = 0;blue[148] = 189;
  red[149] = 49;green[149] = 0;blue[149] = 200;
  red[150] = 45;green[150] = 0;blue[150] = 201;
  red[151] = 40;green[151] = 0;blue[151] = 204;
  red[152] = 35;green[152] = 0;blue[152] = 207;
  red[153] = 30;green[153] = 0;blue[153] = 210;
  red[154] = 26;green[154] = 0;blue[154] = 212;
  red[155] = 20;green[155] = 5;blue[155] = 215;
  red[156] = 16;green[156] = 13;blue[156] = 218;
  red[157] = 11;green[157] = 21;blue[157] = 220;
  red[158] = 6;green[158] = 28;blue[158] = 223;
  red[159] = 2;green[159] = 35;blue[159] = 225;
  red[160] = 0;green[160] = 44;blue[160] = 228;
  red[161] = 0;green[161] = 51;blue[161] = 231;
  red[162] = 0;green[162] = 59;blue[162] = 233;
  red[163] = 0;green[163] = 66;blue[163] = 236;
  red[164] = 0;green[164] = 74;blue[164] = 238;
  red[165] = 0;green[165] = 82;blue[165] = 241;
  red[166] = 0;green[166] = 89;blue[166] = 244;
  red[167] = 0;green[167] = 97;blue[167] = 246;
  red[168] = 0;green[168] = 105;blue[168] = 249;
  red[169] = 0;green[169] = 112;blue[169] = 252;
  red[170] = 0;green[170] = 120;blue[170] = 254;
  red[171] = 0;green[171] = 127;blue[171] = 248;
  red[172] = 0;green[172] = 135;blue[172] = 242;
  red[173] = 0;green[173] = 143;blue[173] = 235;
  red[174] = 0;green[174] = 150;blue[174] = 229;
  red[175] = 0;green[175] = 158;blue[175] = 224;
  red[176] = 0;green[176] = 166;blue[176] = 217;
  red[177] = 0;green[177] = 173;blue[177] = 211;
  red[178] = 0;green[178] = 181;blue[178] = 206;
  red[179] = 0;green[179] = 188;blue[179] = 199;
  red[180] = 0;green[180] = 196;blue[180] = 193;
  red[181] = 0;green[181] = 201;blue[181] = 187;
  red[182] = 0;green[182] = 204;blue[182] = 181;
  red[183] = 0;green[183] = 208;blue[183] = 175;
  red[184] = 0;green[184] = 212;blue[184] = 169;
  red[185] = 0;green[185] = 215;blue[185] = 163;
  red[186] = 0;green[186] = 219;blue[186] = 157;
  red[187] = 0;green[187] = 222;blue[187] = 151;
  red[188] = 0;green[188] = 225;blue[188] = 144;
  red[189] = 0;green[189] = 229;blue[189] = 139;
  red[190] = 0;green[190] = 233;blue[190] = 132;
  red[191] = 0;green[191] = 236;blue[191] = 126;
  red[192] = 0;green[192] = 240;blue[192] = 121;
  red[193] = 0;green[193] = 243;blue[193] = 114;
  red[194] = 0;green[194] = 246;blue[194] = 108;
  red[195] = 0;green[195] = 252;blue[195] = 99;
  red[196] = 0;green[196] = 254;blue[196] = 93;
  red[197] = 0;green[197] = 255;blue[197] = 89;
  red[198] = 0;green[198] = 255;blue[198] = 83;
  red[199] = 0;green[199] = 255;blue[199] = 77;
  red[200] = 0;green[200] = 255;blue[200] = 72;
  red[201] = 0;green[201] = 255;blue[201] = 65;
  red[202] = 6;green[202] = 255;blue[202] = 59;
  red[203] = 18;green[203] = 255;blue[203] = 54;
  red[204] = 30;green[204] = 255;blue[204] = 47;
  red[205] = 43;green[205] = 255;blue[205] = 41;
  red[206] = 55;green[206] = 255;blue[206] = 35;
  red[207] = 66;green[207] = 255;blue[207] = 29;
  red[208] = 79;green[208] = 255;blue[208] = 23;
  red[209] = 91;green[209] = 255;blue[209] = 17;
  red[210] = 103;green[210] = 255;blue[210] = 11;
  red[211] = 115;green[211] = 255;blue[211] = 5;
  red[212] = 127;green[212] = 255;blue[212] = 0;
  red[213] = 140;green[213] = 255;blue[213] = 0;
  red[214] = 152;green[214] = 255;blue[214] = 0;
  red[215] = 164;green[215] = 255;blue[215] = 0;
  red[216] = 176;green[216] = 255;blue[216] = 0;
  red[217] = 188;green[217] = 255;blue[217] = 0;
  red[218] = 201;green[218] = 255;blue[218] = 0;
  red[219] = 212;green[219] = 255;blue[219] = 0;
  red[220] = 224;green[220] = 255;blue[220] = 0;
  red[221] = 237;green[221] = 255;blue[221] = 0;
  red[222] = 249;green[222] = 255;blue[222] = 0;
  red[223] = 255;green[223] = 250;blue[223] = 0;
  red[224] = 255;green[224] = 243;blue[224] = 0;
  red[225] = 255;green[225] = 235;blue[225] = 0;
  red[226] = 255;green[226] = 227;blue[226] = 0;
  red[227] = 255;green[227] = 220;blue[227] = 0;
  red[228] = 255;green[228] = 212;blue[228] = 0;
  red[229] = 255;green[229] = 204;blue[229] = 0;
  red[230] = 255;green[230] = 197;blue[230] = 0;
  red[231] = 255;green[231] = 189;blue[231] = 0;
  red[232] = 255;green[232] = 181;blue[232] = 0;
  red[233] = 255;green[233] = 174;blue[233] = 0;
  red[234] = 255;green[234] = 166;blue[234] = 0;
  red[235] = 255;green[235] = 159;blue[235] = 0;
  red[236] = 255;green[236] = 151;blue[236] = 0;
  red[237] = 255;green[237] = 143;blue[237] = 0;
  red[238] = 255;green[238] = 136;blue[238] = 0;
  red[239] = 255;green[239] = 128;blue[239] = 0;
  red[240] = 255;green[240] = 121;blue[240] = 0;
  red[241] = 255;green[241] = 113;blue[241] = 0;
  red[242] = 255;green[242] = 105;blue[242] = 0;
  red[243] = 255;green[243] = 98;blue[243] = 0;
  red[244] = 255;green[244] = 90;blue[244] = 0;
  red[245] = 255;green[245] = 82;blue[245] = 0;
  red[246] = 255;green[246] = 75;blue[246] = 0;
  red[247] = 255;green[247] = 67;blue[247] = 0;
  red[248] = 255;green[248] = 60;blue[248] = 0;
  red[249] = 255;green[249] = 52;blue[249] = 0;
  red[250] = 255;green[250] = 44;blue[250] = 0;
  red[251] = 255;green[251] = 37;blue[251] = 0;
  red[252] = 255;green[252] = 29;blue[252] = 0;
  red[253] = 255;green[253] = 21;blue[253] = 0;
  red[254] = 255;green[254] = 14;blue[254] = 0;
  red[255] = 255;green[255] = 5;blue[255] = 0;
}

void greycolor()
{
  guint   i;

  for(i=0;i<MAX_COLOR;i++){
    red[i] = green[i] = blue[i] = i;
  }
}
void invgreycolor() /* inverse of gray color */
{
  guint   i;

  for(i=0;i<MAX_COLOR;i++){
    red[MAX_COLOR - i - 1] = green[MAX_COLOR - i - 1] = blue[MAX_COLOR - i - 1] = i;
  }
}

void userdefcolor() /* from lkup file */
{
  char *cbuf,*cbuf1;
  short i;
  FILE *fp;
  int c1,c2,c3;
  unsigned char anar[250],anag[250],anab[250]; /* original analyze lkup hs 250 elements for image */
  unsigned char bkgr,bkgg,bkgb;
  GtkWidget *file_entry;
  const gchar *lkup_file;
  char *ret;

  /* get file name from colorbar_window */
  file_entry = lookup_widget(colorbar_window,"lookup_entry");
  lkup_file = gtk_entry_get_text(GTK_ENTRY(file_entry));
  if(strlen(lkup_file)!=0){
    fp = fopen(lkup_name(lkup_file),"rt");
    if(fp==NULL){
      rainbow();
      return;
    }
    cbuf = (char *)malloc(4096);
    cbuf1 = cbuf; /* just copy for free memory */

    ret = fgets(cbuf,4096,fp);
    /* for background */
    sscanf(cbuf,"%d %d %d",&c1,&c2,&c3);
    bkgr = c1;
    bkgg = c2;
    bkgb = c3;
    cbuf += 12;
    for(i=0;i<250;i++){
      sscanf(cbuf,"%d %d %d",&c1,&c2,&c3);
      anar[i] = c1;
      anag[i] = c2;
      anab[i] = c3;
      cbuf += 12;//forward
    }
    /* assaign color for gpetview */
    for(i=0;i<256;i++){
      red[i] = anar[(int)roundint(249.4/(MAX_COLOR - 1)*i)];
      green[i] = anag[(int)roundint(249.4/(MAX_COLOR - 1)*i)];
      blue[i] = anab[(int)roundint(249.4/(MAX_COLOR -1)*i)];
    }
    red[0] = bkgr;
    green[0] = bkgg;
    blue[0] = bkgb;

    fclose(fp);
    free(cbuf1);
    return;
  }
  /* get lookup from .lkup file */
  if(fname==NULL){
    rainbow();
    return;
  }
  fp = fopen(lkup_name(fname),"rt");
  if(fp==NULL){
    rainbow();
    return;
  }
  cbuf = (char *)malloc(4096);
  cbuf1 = cbuf; /* just copy for free memory */

  ret = fgets(cbuf,4096,fp);
  /* for background */
  sscanf(cbuf,"%d %d %d",&c1,&c2,&c3);
  bkgr = c1;
  bkgg = c2;
  bkgb = c3;
  cbuf += 12;
  for(i=0;i<250;i++){
    sscanf(cbuf,"%d %d %d",&c1,&c2,&c3);
    anar[i] = c1;
    anag[i] = c2;
    anab[i] = c3;
    cbuf += 12;//forward
  }
  /* assaign color for gpetview */
  for(i=0;i<256;i++){
    red[i] = anar[(int)roundint(249.4/(MAX_COLOR - 1)*i)];
    green[i] = anag[(int)roundint(249.4/(MAX_COLOR - 1)*i)];
    blue[i] = anab[(int)roundint(249.4/(MAX_COLOR -1)*i)];
  }
  red[0] = bkgr;
  green[0] = bkgg;
  blue[0] = bkgb;

  fclose(fp);
  free(cbuf1);
}

/* draw color bar routine */
void draw_colorbar()
{
  gint16 unit_h,i,j;
  gint16 color_bar_height, x, y, amari;
  gint16 color_bar_width;
  GdkGC *colorbar_gc;
  GdkColor color;
  guint32 rgb;
  float find;
  char string[256];

  pangocontext = gtk_widget_get_pango_context(gcolorbar);
  pangolayout = pango_layout_new(pangocontext);
  pangofontdesc = pango_font_description_new(); 
  pango_font_description_set_family(pangofontdesc,"monospace"); 
  pango_layout_set_font_description(pangolayout,pangofontdesc); 
  colorbar_gc = gdk_gc_new (gcolorbar->window);
  if (colorbar_gc==NULL){
    return;
  }
  store_rgb();
  color_bar_height = gcolorbar->allocation.height;
  color_bar_width = gcolorbar->allocation.width;
  unit_h = color_bar_height/(MAX_COLOR - 1);
  amari = color_bar_height - unit_h*(MAX_COLOR -1);
  x = 1;

  for(i=0,j=0;i<MAX_COLOR;i++){
    if (clktbl[i]>1.0){
      find = 1.0;
    }
    else{
      find = clktbl[i];
    }
    store_color(&color.pixel,red[(int)(find*(MAX_COLOR -1))],green[(int)(find*(MAX_COLOR -1))],blue[(int)(find*(MAX_COLOR -1))]);
    gdk_gc_set_foreground(colorbar_gc,&color);
    y = color_bar_height - j*unit_h - 1 - amari;
    gdk_draw_rectangle(gcolorbar->window,colorbar_gc,1,x, y, color_bar_width,unit_h);
    j++;
  }
  /* set forground color this is for numbering */
  store_color(&color.pixel,fred,fgreen,fblue);
  gdk_gc_set_foreground(canvasGC,&color); /* set foreground color for canvas */
  if(color_flag == INVGRAY_COLOR){
    store_color(&color.pixel,0,0,0);
  }
  // labeling colorbar
  if(view_flag){
    if(labeling_flag==1){
      if(imax_flag==INPUT_USER_ABS){
	sprintf(string,"%g\0", user_max);
      }
      if(imax_flag==INPUT_USER_REL||imax_flag==EACH_IMAGE){
	sprintf(string,"\0");
      }
      if(imax_flag==ALL_IMAGE){
	sprintf(string,"%g\0", IMAGE_MAX*img->scalefactor);
      }
      store_color(&color.pixel,red[0],green[0],blue[0]);
      gdk_gc_set_foreground(colorbar_gc,&color);
      pango_layout_set_text(pangolayout,string,strlen(string)); 
#ifdef WIN32
      gdk_draw_layout(gcolorbar->window,colorbar_gc,5,20,pangolayout);
#else
      gdk_draw_layout(gcolorbar->window,colorbar_gc,5,10,pangolayout);
#endif
    }
  }
  gdk_gc_destroy(colorbar_gc);
}

/* draw color bar routine */
void draw_colorbar_mini()
{
  gint16 unit_h,i,j;
  gint16 color_bar_height, x, y, amari;
  gint16 color_bar_width;
  GdkGC *colorbar_gc;
  GdkColor color;
  float find;

  colorbar_gc = gdk_gc_new (gcolorbar_mini->window);
  store_rgb();
  color_bar_height = gcolorbar_mini->allocation.height;
  color_bar_width = gcolorbar_mini->allocation.width;
  unit_h = color_bar_height/(MAX_COLOR/2 - 1);
  amari = color_bar_height - unit_h*(MAX_COLOR/2 -1);
  x = 1;

  for(i=0,j=0;i<MAX_COLOR;i+=2){
    if (clktbl[i]>1.0){
      find = 1.0;
    }
    else{
      find = clktbl[i];
    }
    store_color(&color.pixel,red[(int)(find*(MAX_COLOR -1))],green[(int)(find*(MAX_COLOR -1))],blue[(int)(find*(MAX_COLOR -1))]);
    gdk_gc_set_foreground(colorbar_gc,&color);
    y = color_bar_height - j*unit_h - 1 - amari;
    gdk_draw_rectangle(gcolorbar_mini->window,colorbar_gc,1,x, y, color_bar_width,unit_h);
    j++;
  }
  gdk_gc_destroy(colorbar_gc);
}

/* update color bar according to curve */
void update_colorbar()
{
  gint16 unit_h,i,j;
  gint16 color_bar_height, x, y, amari;
  gint16 color_bar_width;
  GdkGC *colorbar_gc;
  GdkColor color;
  GtkCurve *curve;
  float find;
  char string[256];

  curve = (GtkCurve *)lookup_widget(colorbar_window,"colorbarcurve");
  gtk_curve_get_vector(curve,MAX_COLOR,clktbl);

  colorbar_gc = gdk_gc_new (gcolorbar->window);
  color_bar_height = gcolorbar->allocation.height;
  color_bar_width = gcolorbar->allocation.width;
  unit_h = color_bar_height/(MAX_COLOR - 1);
  amari = color_bar_height - unit_h*(MAX_COLOR -1);
  x = 1;

  for(i=0,j=0;i<MAX_COLOR;i++){
    if (clktbl[i]>1.0){
      find = 1.0;
    }
    else{
      find = clktbl[i];
    }
    store_color(&color.pixel,red[(int)(find*(MAX_COLOR -1))],green[(int)(find*(MAX_COLOR -1))],blue[(int)(find*(MAX_COLOR -1))]);
    gdk_gc_set_foreground(colorbar_gc,&color);
    y = color_bar_height - j*unit_h - 1 - amari;
    gdk_draw_rectangle(gcolorbar->window,colorbar_gc,1,x, y, color_bar_width,unit_h);
    j++;
  }
  store_rgb();
  // labeling colorbar
  if(view_flag){
    if(labeling_flag==1){
      if(imax_flag==INPUT_USER_ABS){
	sprintf(string,"%g\0", user_max);
      }
      if(imax_flag==INPUT_USER_REL||imax_flag==EACH_IMAGE){
	sprintf(string,"\0");
      }
      if(imax_flag==ALL_IMAGE){
	sprintf(string,"%g\0", IMAGE_MAX*img->scalefactor);
      }
      store_color(&color.pixel,red[0],green[0],blue[0]);
      gdk_gc_set_foreground(colorbar_gc,&color);
      pango_layout_set_text(pangolayout,string,strlen(string)); 
#ifdef WIN32
      gdk_draw_layout(gcolorbar->window,colorbar_gc,5,20,pangolayout);
#else
      gdk_draw_layout(gcolorbar->window,colorbar_gc,5,10,pangolayout);
#endif
    }
  }
  gdk_gc_destroy(colorbar_gc);
}

/* update color bar mini according to curve */
void update_colorbar_mini()
{
  gint16 unit_h,i,j;
  gint16 color_bar_height, x, y, amari;
  gint16 color_bar_width;
  GdkGC *colorbar_gc;
  GdkColor color;
  GtkCurve *curve;
  gfloat *fcurve;
  float find;
  char str[100];

  fcurve = (gfloat *)malloc(sizeof(gfloat)*MAX_COLOR);
  curve = (GtkCurve *)lookup_widget(colorbar_window,"colorbarcurve");
  gtk_curve_get_vector(curve,MAX_COLOR,fcurve);

  colorbar_gc = gdk_gc_new (gcolorbar_mini->window);
  color_bar_height = gcolorbar_mini->allocation.height;
  color_bar_width = gcolorbar_mini->allocation.width;
  unit_h = color_bar_height/(MAX_COLOR/2 - 1);
  amari = color_bar_height - unit_h*(MAX_COLOR/2 -1);
  x = 1;

  for(i=0,j=0;i<MAX_COLOR;i+=2){
    if (fcurve[i]>1.0){
      find = 1.0;
    }
    else{
      find = fcurve[i];
    }
    store_color(&color.pixel,red[(int)(find*(MAX_COLOR-1))],green[(int)(find*(MAX_COLOR-1))],blue[(int)(find*(MAX_COLOR-1))]);
    gdk_gc_set_foreground(colorbar_gc,&color);
    y = color_bar_height - j*unit_h - 1 - amari;
    gdk_draw_rectangle(gcolorbar_mini->window,colorbar_gc,1,x, y, color_bar_width,unit_h);
    j++;
  }
  gdk_gc_destroy(colorbar_gc);
  free(fcurve);
}

/* Save lookup color table */
void save_lookup()
{
  gint16 i;
  GtkCurve *curve;
  float find;
  gfloat *fcurve;
  FILE *fp;
  GtkWidget *file_entry;
  const gchar *lkup_file;

  /* get file name from colorbar_window */
  file_entry = lookup_widget(colorbar_window,"lookup_entry");
  lkup_file = gtk_entry_get_text(GTK_ENTRY(file_entry));
  fp = fopen(lkup_name(lkup_file),"wt");
  fcurve = (gfloat *)malloc(sizeof(gfloat)*250);//analyze lookup has 250 entries
  curve = (GtkCurve *)lookup_widget(colorbar_window,"colorbarcurve");
  gtk_curve_get_vector(curve,250,fcurve);//analyze lookup has 250 entries

  fprintf(fp,"000 000 000 "); // for background color

  for(i=0;i<250;i++){//analyze lookup has 250 entries
    if (fcurve[i]>1.0){
      find = 1.0;
    }
    else{
      find = fcurve[i];
    }
    fprintf(fp,"%.3d %.3d %.3d ",red[(int)(find*(MAX_COLOR -1))],green[(int)(find*(MAX_COLOR -1))],blue[(int)(find*(MAX_COLOR -1))]);
  }
  free(fcurve);
  fclose(fp);
  update_colorbar_mini();
}

void store_rgb()
{
  int i;
  float find;

  if(color_flag == RAINBOW_COLOR){
    rainbow();
  }
  else{
    if(color_flag == GRAY_COLOR){
      greycolor();
    }
    else{
      if(color_flag == HOT_COLOR){
	hotcolor();
      }
      else{
	if(color_flag == COMB_COLOR){
	  combcolor();
	}
	else{
	  if(color_flag == LKUP_COLOR){
	    userdefcolor();
	  }
	  else{
	    if(color_flag == INVGRAY_COLOR){
	      invgreycolor();
	    }
	  }
	}
      }
    }
  }
  /* create RGB colormap for index image */
  for(i=0;i<MAX_COLOR;i++){
    if (clktbl[i]>1.0){
      find = 1.0;
    }
    else{
      find = clktbl[i];
    }
    //    pet_cmap->lut[i] = gdk_rgb_xpixel_from_rgb((red[(int)(find*(MAX_COLOR -1))] << 16) | (green[(int)(find*(MAX_COLOR -1))] << 8) | blue[(int)(find*(MAX_COLOR -1))]);
    pet_cmap->colors[i] = (red[(int)(find*(MAX_COLOR -1))]<<16)|(green[(int)(find*(MAX_COLOR -1))]<<8) |blue[(int)(find*(MAX_COLOR -1))];
  }
}
