/* Copyright 2000-2011 Hiroshi Watabe*/
/* $Id: draw_image.c,v ad5996c60c95 2011/02/03 09:07:37 watabe $ */
/* Draw image */
#include "gpetview.h"

extern guchar seq_flag;
extern float zoom_factor;
extern unsigned int z_xdim, z_ydim, z_zdim; /* after zooming */
extern ImageRectPointer *image_cell;
extern guchar imax_flag;
extern int depth;
extern guchar ismax;

unsigned char numbering_flag = 1;
unsigned char interpolate_flag = 1;
guchar revy_flag = 1; /* reverse Y axis */

unsigned char *zooming(unsigned char *buf, gushort cur_x, gushort cur_y,gushort r_x,gushort yoko,gushort tate)
{
  unsigned char *zbuf=NULL;
  unsigned int i,ii,j,jj;
  int xcoord, ycoord;
  int xcoord2, ycoord2;
  short k222,k122,k212,k112;
  float dx1,dy1,dx2,dy2;
  unsigned char dat;
  float	ftmp1,ftmp2;

  if(zoom_factor==1.0){
    return(buf);
  }
  zbuf = (unsigned char *)realloc(zbuf,cur_x*cur_y);

  if(interpolate_flag==1){
    for(i=0,ii=0;i<cur_y;i++,ii++){
      for(j=0,jj=0;j<cur_x;j++,jj++){
	ftmp2 = (i - 0.5)/zoom_factor + 0.5;
	ftmp1 = (j - 0.5)/zoom_factor + 0.5;
	xcoord2 = xcoord = ftmp1;
	ycoord2 = ycoord = ftmp2;
	dx1=ftmp1 - xcoord;
	dx2=1.0-dx1;
	dy1=ftmp2 - ycoord;
	dy2=1.0-dy1;
	xcoord--;
	ycoord--;
	/*Calculate the interpolation weighting factors*/
	/*Calculate the interpolated reslice value of pixel t*/
	if(ycoord<0||ycoord2>=tate||xcoord<0||xcoord2>=yoko) dat = 0;
	else{
	  k222 = buf[xcoord  + r_x*ycoord];
	  k122 = buf[xcoord2 + r_x*ycoord];
	  k212 = buf[xcoord  + r_x*ycoord2];
	  k112 = buf[xcoord2 + r_x*ycoord2];
	  dat = k222*dx2*dy2 + k122*dx1*dy2 + k212*dx2*dy1 + k112*dx1*dy1;
	}
	zbuf[jj + cur_x*ii] = dat;
      }
    }
  }
  /* nearest neighbor */
  else{
    for(i=0,ii=0;i<cur_y;i++,ii++){
      for(j=0,jj=0;j<cur_x;j++,jj++){
	ftmp2 = (i - 0.5)/zoom_factor + 0.5;
	ftmp1 = (j - 0.5)/zoom_factor + 0.5;
	xcoord = roundint(ftmp1) - 1;
	ycoord = roundint(ftmp2) - 1;
	k222 = buf[xcoord  + r_x*ycoord];
	if(ycoord<0) dat = 0;
	else{
	  dat = k222;
	}
	zbuf[jj + cur_x*ii] = dat;
      }
    }
  }
  return(zbuf);
}

void draw_image(guchar *buf,guint32 xdim, guint32 ydim, guint32 zdim, guint32 inum,guchar draw_flag)
{
  int i,j;
  guchar dat;
  gushort cur_x=0,cur_y=0, r_x=0;
  char string[256];
  float scale;
  float ftmp;
  gushort yoko,tate;
  GdkColor color;

  if(color_flag==INVGRAY_COLOR){
    store_color(&color.pixel,0,0,0);// black numbering
  }
  else{
    store_color(&color.pixel,255,255,255); //white numbering
  }
  gdk_gc_set_foreground(numberGC,&color);

  if(seq_flag==TRANS){
    r_x = xdim;
    cur_x = z_xdim;
    cur_y = z_ydim;
    yoko = xdim;
    tate = ydim;
  }
  if(seq_flag==CORO){
    r_x = xdim;
    cur_x = z_xdim;
    cur_y = z_zdim;
    yoko = xdim;
    tate = zdim;
  }
  if(seq_flag==SAGI){
    r_x = ydim;
    cur_x = z_ydim;
    cur_y = z_zdim;
    yoko = ydim;
    tate = zdim;
  }
  buf = zooming(buf,cur_x,cur_y,r_x,yoko,tate);

  for(i=0;i<cur_y;i++){
    for(j=0;j<cur_x;j++){
      if(revy_flag) dat = buf[j + cur_x*(cur_y -1 - i)];
      else  dat = buf[j + cur_x*i];
      if(imax_flag == INPUT_USER_REL){
	if(dat>(user_max/img->scalefactor)) dat = user_max/img->scalefactor;
	if(dat<(user_min/img->scalefactor)) dat = user_min/img->scalefactor;
	scale = (float)(MAX_COLOR - 1)/(user_max - user_min)*img->scalefactor;
	dat = (dat - (int)(user_min/img->scalefactor))*scale;
      }
      else{
	if(imax_flag == INPUT_USER_ABS){
	  if((dat*img->scalefactor + img->hdr->dime.cal_min)>user_max){
	    ftmp = (user_max - img->hdr->dime.cal_min)/img->scalefactor;
	    if(ftmp>(MAX_COLOR - 1)){
	      dat = MAX_COLOR - 1;
	    }
	    else{
	      dat = (guchar)ftmp;
	    }
	  }
	  if((dat*img->scalefactor + img->hdr->dime.cal_min)<user_min){
	    ftmp = (user_min - img->hdr->dime.cal_min)/img->scalefactor;
	    if(ftmp<0){
	      dat = 0;
	    }
	    else{
	      dat = (guchar)ftmp;
	    }
	  }
	  scale = (float)(MAX_COLOR - 1)/(user_max - user_min);
	  ftmp = (dat*img->scalefactor + img->hdr->dime.cal_min - user_min)*scale;
	  dat = (guchar)ftmp;
	  if(ftmp>(MAX_COLOR - 1)){
	      dat = MAX_COLOR - 1;
	  }
	  if(ftmp<0){
	    dat = 0;
	  }
	}
	else{
	  scale = (float)(MAX_COLOR - 1)/(float)ismax;
	  if(revy_flag) dat = buf[j + cur_x*(cur_y -1 - i)]*scale;/* can deal with imax_flag = ALL_IMAGE or EACH_IMAGE */
	  else dat = buf[j + cur_x*i]*scale;/* can deal with imax_flag = ALL_IMAGE or EACH_IMAGE */
	}
      }
      Image[j + cur_x*(i)] = dat;
    }
  }
  gdk_draw_indexed_image(canvas_pixmap,canvasGC,image_cell[inum]->r_left,image_cell[inum]->r_top,image_cell[inum]->r_width,image_cell[inum]->r_height,GDK_RGB_DITHER_NONE,Image,cur_x,pet_cmap);

  if(numbering_flag==1){

    sprintf(string,"%5d\0",image_cell[inum]->img_no);
    pango_layout_set_text(canvas_layout,string,strlen(string)); 
    gdk_draw_layout(canvas_pixmap,numberGC,image_cell[inum]->r_left + 1,image_cell[inum]->r_top + 12,canvas_layout);
  }
  if(draw_flag){/* draw canvas */
    //gdk_window_copy_area(pet_canvas->window,canvasGC,0,0,canvas_pixmap,0,0,canvas_width,canvas_height);
    gdk_window_copy_area(pet_canvas->window,canvasGC,image_cell[inum]->r_left,image_cell[inum]->r_top,canvas_pixmap,image_cell[inum]->r_left,image_cell[inum]->r_top,image_cell[inum]->r_width,image_cell[inum]->r_height);
  }
}
