/* Copyright 2000-2010 Hiroshi Watabe */
/* Initialize gpetview */
/* $Id: init_gpetview.c,v e4069cee58dc 2010/10/26 12:11:37 watabe $ */
#include "gpetview.h"

float clktbl[256]; /* color lookup table */
char title[1024];
guchar always_pickp_flag = 0;

void init_gpetview()
{
  char *env_home_dir;
  char rcname[255];
  FILE *fp;
  char sbuf[255],char1[10],char2[10],char3[10],char4[10];
  GtkWidget *button;
  int i;

  gcolorbar = lookup_widget(gpetview,"colorbar");
  gcolorbar_mini = lookup_widget(colorbar_window,"minicolorbar_area");
  /* initialize clktbl color lookup table */
  for(i=0;i<MAX_COLOR;i++){
    clktbl[i] = (float)i/(float)MAX_COLOR;
  }
  /* clear title */
  memset(title,0,1024);

#ifdef WIN32
  sprintf(rcname,"gpetviewrc");
#else
  env_home_dir = getenv("HOME");
  sprintf(rcname,"%s/.gpetviewrc",env_home_dir);
#endif
  fp = fopen(rcname,"rt");
  if(fp==NULL){
    /* initialize all params */
    color_flag = RAINBOW_COLOR;
    numbering_flag = 1;
    labeling_flag = 0;
    interpolate_flag = 1;
    seq_flag = TRANS;
    zoom_factor = 1.0;
    imax_flag = ALL_IMAGE;
    revy_flag = 1;
  }
  else{
    /* find color */
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"color",5)==0){
#else
      if(strncasecmp(sbuf,"color",5)==0){
#endif
	sscanf(sbuf,"%s %s\n",char1,char2);
#ifdef WIN32
	if(strncmp(char2,"rainbow",7)==0){
#else
	if(strncasecmp(char2,"rainbow",7)==0){
#endif
	  color_flag = RAINBOW_COLOR;
	  button = lookup_widget(colorbar_window,"set_rainbow_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
#ifdef WIN32
	  if(strncmp(char2,"hot",3)==0){
#else
	  if(strncasecmp(char2,"hot",3)==0){
#endif
	    color_flag = HOT_COLOR;
	    button = lookup_widget(colorbar_window,"set_hot_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	  }
	  else{
#ifdef WIN32
	    if(strncmp(char2,"gray",4)==0){
#else
	    if(strncasecmp(char2,"gray",4)==0){
#endif
	      color_flag = GRAY_COLOR;
	      button = lookup_widget(colorbar_window,"set_gray_button");
	      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	    }
	    else{
#ifdef WIN32
	      if(strncmp(char2,"lkup",4)==0){
#else
	      if(strncasecmp(char2,"lkup",4)==0){
#endif
		color_flag = LKUP_COLOR;
		button = lookup_widget(colorbar_window,"set_lkup_button");
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	      }
	      else{
#ifdef WIN32
		if(strncmp(char2,"invgray",7)==0){
#else
		if(strncasecmp(char2,"invgray",7)==0){
#endif
		  color_flag = INVGRAY_COLOR;
		  button = lookup_widget(colorbar_window,"set_invgray_button");
		  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
		}
		else{
		  color_flag = RAINBOW_COLOR;
		}
	      }
	    }
	  }
	}
	break;
      }
      if(feof(fp)){
	color_flag = RAINBOW_COLOR;
	break;
      }
    }
  /* Labeling */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"label",5)==0){
#else
      if(strncasecmp(sbuf,"label",5)==0){
#endif
	sscanf(sbuf,"%s %s\n",char1,char2);
#ifdef WIN32
	if(strncmp(char2,"on",2)==0){
#else
	if(strncasecmp(char2,"on",2)==0){
#endif
	  labeling_flag = 1;
	  button = lookup_widget(settingshell,"label_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
#ifdef WIN32
	  if(strncmp(char2,"off",3)==0){
#else
	  if(strncasecmp(char2,"off",3)==0){
#endif
	    labeling_flag = 0;
	    button = lookup_widget(settingshell,"label_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), FALSE);
	  }
	  else{
	    labeling_flag = 0;
	  }
	}
	break;
      }
      if(feof(fp)){
	labeling_flag = 1;
	break;
      }
    }
    /* set section*/
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"slice",5)==0){
#else
      if(strncasecmp(sbuf,"slice",5)==0){
#endif
	sscanf(sbuf,"%s %s\n",char1,char2);
#ifdef WIN32
	if(strncmp(char2,"trans",5)==0){
#else
	if(strncasecmp(char2,"trans",5)==0){
#endif
	  seq_flag = TRANS;
	  button = lookup_widget(settingshell,"set_trans_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
#ifdef WIN32
	  if(strncmp(char2,"coro",4)==0){
#else
	  if(strncasecmp(char2,"coro",4)==0){
#endif
	    seq_flag = CORO;
	    button = lookup_widget(settingshell,"set_coronal_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	  }
	  else{
#ifdef WIN32
	    if(strncmp(char2,"sagi",4)==0){
#else
	    if(strncasecmp(char2,"sagi",4)==0){
#endif
	      seq_flag = SAGI;
	      button = lookup_widget(settingshell,"set_sagital_button");
	      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	    }
	    else{
	      seq_flag = TRANS;
	    }
	  }
	}
	break;
      }
      if(feof(fp)){
	seq_flag = TRANS;
	break;
      }
    }
  /* Zooming */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"zoom",4)==0){
#else
      if(strncasecmp(sbuf,"zoom",4)==0){
#endif
	sscanf(sbuf,"%s %s\n",char1,char2);
	zoom_factor = (float)atof(char2);
	if(zoom_factor<=0){
	  zoom_factor = 1.0;
	  break;
	}
	else{
	  button = lookup_widget(settingshell,"set_zoom");
	  gtk_entry_set_text (GTK_ENTRY (button), char2);
	  break;
	}
      }
      if(feof(fp)){
	zoom_factor = 1.0;
	break;
      }
    }
  /* imax */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"max",3)==0){
#else
      if(strncasecmp(sbuf,"max",3)==0){
#endif
	sscanf(sbuf,"%s %s\n",char1,char2);
#ifdef WIN32
	if(strncmp(char2,"all",3)==0){
#else
	if(strncasecmp(char2,"all",3)==0){
#endif
	  imax_flag = ALL_IMAGE;
	  button = lookup_widget(settingshell,"set_all_image_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
#ifdef WIN32
	  if(strncmp(char2,"each",4)==0){
#else
	  if(strncasecmp(char2,"each",4)==0){
#endif
	    imax_flag = EACH_IMAGE;
	    button = lookup_widget(settingshell,"set_each_image_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	  }
	  else{
	    imax_flag = ALL_IMAGE;
	  }
	}
	break;
      }
      if(feof(fp)){
	imax_flag = ALL_IMAGE;
	break;
      }
    }
  /* ReverseY */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"revy",4)==0){
#else
      if(strncasecmp(sbuf,"revy",4)==0){
#endif
	sscanf(sbuf,"%s %s\n",char1,char2);
#ifdef WIN32
	if(strncmp(char2,"on",2)==0){
#else
	if(strncasecmp(char2,"on",2)==0){
#endif
	  revy_flag = 1;
	  button = lookup_widget(settingshell,"revy_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	}
	else{
	  revy_flag = 0;
	  button = lookup_widget(settingshell,"revy_button");
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), FALSE);
	}
	break;
      }
      if(feof(fp)){
	revy_flag = 1;
	break;
      }
    }
  /* Window size */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"window",6)==0){
#else
      if(strncasecmp(sbuf,"window",6)==0){
#endif
	sscanf(sbuf,"%s %s %s\n",char1,char2,char3);
	view_width = atoi(char2);
	view_height = atoi(char3);
	break;
      }
      if(feof(fp)){
	break;
      }
    }
  /* Canvas size */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"canvas",6)==0){
#else
      if(strncasecmp(sbuf,"canvas",6)==0){
#endif
	sscanf(sbuf,"%s %s %s\n",char1,char2,char3);
	canvas_width = atoi(char2);
	canvas_height = atoi(char3);
	break;
      }
      if(feof(fp)){
	break;
      }
    }
  /* line width size */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"lwidth",6)==0){
#else
      if(strncasecmp(sbuf,"lwidth",6)==0){
#endif
	sscanf(sbuf,"%s %s\n",char1,char2);
	line_width = atoi(char2);
	break;
      }
      if(feof(fp)){
	break;
      }
    }
  /* Foreground color */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"forec",5)==0){
#else
      if(strncasecmp(sbuf,"forec",5)==0){
#endif
	sscanf(sbuf,"%s %s %s %s\n",char1,char2,char3,char4);
	fred = atoi(char2);
	fgreen = atoi(char3);
	fblue = atoi(char4);
	break;
      }
      if(feof(fp)){
	break;
      }
    }
  /* Pickp */
    fseek(fp,0,0);
    while(1){
      fgets(sbuf,255,fp);
#ifdef WIN32
      if(strncmp(sbuf,"pickp",5)==0){
#else
      if(strncasecmp(sbuf,"pickp",5)==0){
#endif
	sscanf(sbuf,"%s %s\n",char1,char2);
#ifdef WIN32
	if(strncmp(char2,"on",2)==0){
#else
	if(strncasecmp(char2,"on",2)==0){
#endif
	  roi_flag = figure.type = PICKP;
	  roi_draw_flag = 1;
	  always_pickp_flag = 1;
	}
	break;
      }
      if(feof(fp)){
	break;
      }
    }
    fclose(fp);
  }
}
