/* Copyright 2000-2006 Hiroshi Watabe */
/* $Id: pipe.c,v f4d449a26330 2010/04/14 21:14:30 watabe $ */
/* read image from pipe */
#include "gpetview.h"

FRSTR *getpipe()
{
  FRSTR *img;
  int frsize,ret;
  FILE *pipe;
  guchar *tmpbuf;

  if(pipe_fd==0){
    pipe = stdin;
  }
  else{
    pipe = fdopen(pipe_fd,"rb");
  }

  img = (FRSTR *)malloc(sizeof(FRSTR));
  img->hdr = (struct dsr *)malloc(sizeof(struct dsr));
  ret = fread(img->hdr,1,sizeof(struct dsr),pipe);
  if(img->hdr->hk.sizeof_hdr!=sizeof(struct dsr)){
    need_swap_flag = 1;
    exchange_hdr(img->hdr);
  }
  else need_swap_flag = 0;
  if(img->hdr->dime.dim[4]==0){//we need tdim >= 1
	img->hdr->dime.dim[4] = 1;
  }
  frsize = frame_size(img->hdr);
  img->dat = (guchar *)malloc(frsize);
  if(img->hdr->dime.vox_offset>0){//for pipe we cannot use fseek
    tmpbuf = (guchar *)malloc(img->hdr->dime.vox_offset);
    ret = fread(tmpbuf,1,img->hdr->dime.vox_offset,pipe);
    free(tmpbuf);
  }
  ret = fread(img->dat,1,frsize,pipe);
  img->frameno = 1;/* assume always first frame */
  if(img->hdr->dime.funused1==0){
    img->scalefactor = 1.0;
  }
  else{
    img->scalefactor = img->hdr->dime.funused1;
  }
  return(img);
}
