/* Copyright 2000-2010 Hiroshi Watabe*/
/* Save and Load ROI data file */
/* $Id: save_roi.c,v 98c88d5452fb 2010/08/24 13:24:08 watabe $ */
#include "gpetview.h"

void save_roi_proc()
{
  const gchar *str;
  char st[1024],st2[1024];
  gushort n_from,n_to,i;
  FILE *fp,*fp2;
  ROIINFO roi_info;
  GtkWidget *roi_file_entry;
  GtkWidget *roi_no_from_entry;
  GtkWidget *roi_no_to_entry;

  roi_file_entry = lookup_widget(roiwindow,"roi_file_entry");
  str =  gtk_entry_get_text(GTK_ENTRY(roi_file_entry));
  if(strlen(str)==0){return;}
  roi_no_from_entry = lookup_widget(roiwindow,"roi_no_from_entry");
  n_from = atoi(gtk_entry_get_text(GTK_ENTRY(roi_no_from_entry)));
  roi_no_to_entry = lookup_widget(roiwindow,"roi_no_to_entry");
  n_to = atoi(gtk_entry_get_text(GTK_ENTRY(roi_no_to_entry)));

  if(n_from==0) n_from = 1;
  if(n_to==0) n_to = roi_num;
  for(i=n_from;i<=n_to;i++){
    if(i>roi_num) break;
#ifdef WIN32
    if (flag_roidir==1){
      sprintf(st,"%s\\roi%s.%d",temproidir,timestamp,i);
    }
    else{
      sprintf(st,"roi%s.%d",timestamp,i);
    }
#else
    if(flag_roidir==1){
      sprintf(st,"%s/roi%s.%d",temproidir,timestamp,i);
    }
    else{
      sprintf(st,"/tmp/roi%s.%d",timestamp,i);
    }
#endif
    sprintf(st2,"%s.roi%d",str,i - n_from + 1);
    fp = fopen(st,"rb");
    fp2 = fopen(st2,"wb");
    fread(&roi_info,sizeof(roi_info),1,fp);
    fwrite(&roi_info,sizeof(roi_info),1,fp2);
    fclose(fp);
    fclose(fp2);
  }
}

/* reverse roi */
int revy_roi(ROIINFO *roi_info)
{
  gushort fukasa;
  int i;

  if(seq_flag==TRANS){
    fukasa = ydim*zoom_factor;
  }
  else{
    if(seq_flag==CORO){
      fukasa = zdim*zoom_factor;
    }
    else{
      fukasa = zdim*zoom_factor;
    }
  }
  roi_info->figure.center.y = fukasa - roi_info->figure.center.y;
  if(roi_info->figure.type==POLYGON){
    for(i=0;i< roi_info->figure.pnum;i++){
      roi_info->figure.points[i].y = fukasa - roi_info->figure.points[i].y;
    }
  }
}


void load_roi_proc()
{
  const gchar *str,*str2;
  char st[100],st2[100];
  gushort n_from,n_to,i,j;
  FILE *fp;
  ROIINFO roi_info;
  GtkWidget *roi_file_entry;
  GtkWidget *roi_no_from_entry;
  GtkWidget *roi_no_to_entry;

  roi_file_entry = lookup_widget(roiwindow,"roi_file_entry");
  str =  gtk_entry_get_text(GTK_ENTRY(roi_file_entry));
  if(strlen(str)==0){return;}
  roi_no_from_entry = lookup_widget(roiwindow,"roi_no_from_entry");
  str2 =  gtk_entry_get_text(GTK_ENTRY(roi_no_from_entry));
  n_from = atoi(str2);
  roi_no_to_entry = lookup_widget(roiwindow,"roi_no_to_entry");
  str2 =  gtk_entry_get_text(GTK_ENTRY(roi_no_to_entry));
  n_to = atoi(str2);

  if(n_from==0||n_to==0){
    sprintf(st2,"Please specify from and to region!!");
    put_string(st2,0);
    return;
    }
  for(i=n_from,j=roi_num+1;i<=n_to;i++,j++){
    sprintf(st2,"%s.roi%d",str,i);
    if((fp=fopen(st2,"rb"))==NULL){
      sprintf(st,"Cannot find file %s!!",st2);
      put_string(st,0);
      continue;
    }
    fread(&roi_info,sizeof(roi_info),1,fp);
    if(roi_info.figure.type>1000){/* we need swap */
      swap_roi_info(&roi_info);
    }
    if(roi_info.orient!=seq_flag){
      if(roi_info.orient==TRANS){
	sprintf(st,"Transverse in ROI %d. Change Orientation!!",i);
	put_string(st,0);
      }
      if(roi_info.orient==CORO){
	sprintf(st,"Coronal in ROI %d. Change Orientation!!",i);
	put_string(st,0);
      }
      if(roi_info.orient==SAGI){
	sprintf(st,"Sagittal in ROI %d. Change Orientation!!",i);
	put_string(st,0);
      }
      fclose(fp);
      continue;
    }
    if(roi_info.zoom!=zoom_factor){
      zoom_off(&roi_info);
    }
    if(roi_info.revy_flag>1) roi_info.revy_flag=1; /* old ROI file doens't have revy_flag */
    if(roi_info.revy_flag!=revy_flag){
      sprintf(st,"Warning. Reversing Y");
      put_string(st,0);
      revy_roi(&roi_info);
      //      fclose(fp);
      //      continue;
    }
    for(j=0;j<num_max_image;j++){
      if(image_cell[j]->img_no==END_IMAGE){
	sprintf(st,"Cannot find image number in Roi %d!!",i);
	put_string(st,0);
	//	fclose(fp);
	break;
      }
      if(roi_info.img_no == image_cell[j]->img_no){
	roi_flag = roi_info.figure.type;
	if(roi_flag==POLYGON) Close = 1;
	memcpy(&figure,&(roi_info.figure),sizeof(figure));
	curr_img_roi = j;
	roi_draw_flag = 1;
	roi_calc();
	roi_out();
	break;
      }
    }
    if(j==num_max_image){//cannot find mathing image for the ROI
      sprintf(st,"Cannot find image %d in ROI %d!!",roi_info.img_no,i);
      put_string(st,0);
    }
    fclose(fp);
  }
}

void swap_roi_info(ROIINFO *roi_info)
{
  ROIINFO local_roi_info;
  int i;

  memcpy(&local_roi_info,roi_info,sizeof(ROIINFO));
  roi_info->img_no = swap_short(local_roi_info.img_no);
  roi_info->zoom = swap_float(local_roi_info.zoom);
  roi_info->figure.type = swap_int(local_roi_info.figure.type);
  roi_info->figure.center.x = swap_short(local_roi_info.figure.center.x);
  roi_info->figure.center.y = swap_short(local_roi_info.figure.center.y);
  roi_info->figure.la = swap_int(local_roi_info.figure.la);
  roi_info->figure.sa = swap_int(local_roi_info.figure.sa);
  roi_info->figure.degree = swap_float(local_roi_info.figure.degree);
  roi_info->figure.pnum = swap_int(local_roi_info.figure.pnum);
  for(i=0;i<roi_info->figure.pnum;i++){
    roi_info->figure.points[i].x = swap_short(local_roi_info.figure.points[i].x);
    roi_info->figure.points[i].y = swap_short(local_roi_info.figure.points[i].y);
  }
}

/* zooming off for calculation of ROI */
void zoom_off(ROIINFO *roi_info)
{
  int i;
  float factor;
  factor = zoom_factor/roi_info->zoom;
  //  printf("zoom %g %g %g\n",zoom_factor,roi_info->zoom,factor);
  if(roi_info->figure.type==POLYGON){
    for(i=0;i<roi_info->figure.pnum;i++){
      roi_info->figure.points[i].x = roundint((double)roi_info->figure.points[i].x*factor);
      roi_info->figure.points[i].y = roundint((double)roi_info->figure.points[i].y*factor);
    }
  }
  else{
    roi_info->figure.center.x = roundint((double)roi_info->figure.center.x*factor);
    roi_info->figure.center.y = roundint((double)roi_info->figure.center.y*factor);
    roi_info->figure.la = roundint((double)roi_info->figure.la*factor);
    roi_info->figure.sa = roundint((double)roi_info->figure.sa*factor);
  }
}
